<?php

defined('_JEXEC') or die('Restricted Access');
include("QazLatynHelper.php");

class PlgSystemQazLatynConverter extends JPlugin
{
    public function __construct(&$subject, $config) {
		parent::__construct($subject, $config);
		JFactory::getDocument()->addScript(jUri::root().'plugins/system/qazlatynconverter/js/qazlatynconverter.js');
    }
	PUBLIC FUNCTION onAfterRender()
	{	
		$app = JFactory::getApplication();
		if($app->isSite() && !class_exists('JEditor', false))
		{
		   $ln = JFactory::getApplication()->input->get('ln','','filter');
		   if($ln == "latyn"){
		     $html = $app->getBody();
			 $html = $this->cyrl2latyn($html);
			 $app->setBody($html);
		   }
		   
		}
	}

	PRIVATE FUNCTION cyrl2latyn($html){
		$dom = new DOMDocument();
		@$dom->loadHTML($html);
		$xpath = new DOMXPath($dom);
	
	//text nodes
	$textNodes = $xpath->evaluate("//text()[normalize-space(.) != '']");
	for ($i = 0; $i < $textNodes->length; $i++) {
		   $textNode = $textNodes->item($i);
		   $nodeValue = $textNode->nodeValue;
		   $textNode->nodeValue = QazLatynHelper::Cyrl2Latyn($nodeValue);
	}
	//input nodes
	$inputNodes = $xpath->evaluate("//input[contains(@type,'text')]|//textarea");
	for ($i = 0; $i < $inputNodes->length; $i++) {
		   $inputNode = $inputNodes->item($i);
		   $placeholder = $inputNode->getAttribute('p laceholder');
		   $placeholder = QazLatynHelper::Cyrl2Latyn($placeholder);
		   $inputNode->setAttribute('placeholder', $placeholder);
	}
	//link nodes
	
	$linkNodes = $xpath->evaluate("//a");
	$siteUrl =  $this->get_site_url();
	for ($i = 0; $i < $linkNodes->length; $i++) {
		   $linkNode = $linkNodes->item($i);
		   $url = strtolower($linkNode->getAttribute('href'));
		   $linkNode->setAttribute('href', $siteUrl);
		   if(strpos($url, $siteUrl) !== false||(strlen($url)>0 && substr($url,0,1) == "/")){
				$url = $this->modify_url_query($url, array('ln' => 'latyn'));
				$linkNode->setAttribute('href', $url);
		   }
	}
	
		return $dom->saveHTML();
	}
	PRIVATE FUNCTION get_site_url(){
		$siteUrl =  strtolower(JURI::base());
		$purl = parse_url($siteUrl);
		$ret = "";
		if (isset($purl['scheme']) && $purl['scheme'])
		{
			$ret = $purl['scheme'] . "://";
		}    
		if (isset($purl['host']) && $purl['host'])
		{
			$ret .= $purl['host'];
		}    
		return $ret;
	}
	PRIVATE FUNCTION modify_url_query($url, $mod){
		$purl = parse_url($url);
		$params = array();
		if (isset($purl['query']) &&($query_str=$purl['query']))
		{
			parse_str($query_str, $params);
		
			foreach($params as $name => $value)
			{
				if (isset($mod[$name]))
				{
					$params[$name] = $mod[$name];
					unset($mod[$name]);
				}
			}
		}        
		$params = array_merge($params, $mod);
		$ret = "";
		if (isset($purl['scheme']) && $purl['scheme'])
		{
			$ret = $purl['scheme'] . "://";
		}    
		if (isset($purl['host']) && $purl['host'])
		{
			$ret .= $purl['host'];
		}    
		if (isset($purl['path']) && $purl['path'])
		{
			$ret .= $purl['path'];
		}    
		if ($params)
		{
			$ret .= '?' . http_build_query($params);
		}    
		if (isset($purl['fragment']) && $purl['fragment'])
		{
			$ret .= "#" . $purl['fragment'];
		}        
	   return $ret;
	}
}



