<?PHP
class Sound
{
    const Vowel = 1; //Дауысты дыбыс
    const Consonant = 2; //Дауыссыз дыбыс
    const Unknown = 3; //Белгісіз
}

class QazLatynHelper
{


    private static $cyrlChars = array( 'А', 'Ә', 'Ə', 'Б', 'В', 'Г', 'Ғ', 'Д', 'Е', 'Ё', 'Ж', 'З', 'И', 'Й', 'К', 'Қ', 'Л', 'М', 'Н', 'Ң', 'О', 'Ө', 'Ɵ', 'П', 'Р', 'С', 'Т', 'У', 'Ұ', 'Ү', 'Ф', 'Х', 'Һ', 'Ц', 'Ч', 'Ш', 'Щ', 'Ъ', 'Ы', 'І', 'Ь', 'Э', 'Ю', 'Я', '-');
    private static $vowelChars = array( 'А', 'Ә', 'Ə', 'Е', 'И', 'О', 'Ө', 'Ɵ', 'Ұ', 'Ү', 'У', 'Ы', 'І', 'Э' );
    private static $wordsPackDic = array('автономия' => 'avtonomıa','саясатшыл' => 'saıasatshyl','сенсуалист' => 'sensýalıs','саяздату' => 'saıazdatý','онкологиялық' => 'onkologıalyq','археография' => 'arheografıa','жаю' => 'jaıý','аллалы' => 'allaly','бильярд' => 'bılárd','зарядтау' => 'zarádtaý','шаяндай' => 'shaıandaı','нитробояғыштар' => 'nıtroboıaǵyshtar','шлюзсіз' => 'shlúzsiz','ямайлық' => 'ıamaılyq','қазия' => 'qazıa','шипая' => 'shıpaıa','мобилизация' => 'mobılızasıa','тәйтию' => 'táıtıý','саяхат' => 'saıahat','вагонша' => 'vagonsha','тайтұяқ' => 'taıtuıaq','парфюмерші' => 'parfúmershi','аэротерапия' => 'aeroterapıa','монархист' => 'monarhıs','делию' => 'delıý','шұқию' => 'shuqıý','лексикографиялық' => 'leksıkografıalyq','пая' => 'paıa','қоярда-қоймай' => 'qoıarda-qoımaı','талассыз' => 'talassyz','антикоммунизм' => 'antıkomýnızm','конфессияаралық' => 'konfesıaaralyq','атолл' => 'atol','педиатрия' => 'pedıatrıa','милливольт' => 'mıllıvolt','аяңшыл' => 'aıańshyl','япырым-ай' => 'ıapyrym-aı','шаян' => 'shaıan','материалист' => 'materıalıs','қиянат-зұлымдық' => 'qıanat-zulymdyq','ұятсыздық' => 'uıatsyzdyq','ноктюрн' => 'noktúrn','кардиограмма' => 'kardıogram','ақсию' => 'aqsıý','жаяужарыс' => 'jaıaýjarys','фономорфология' => 'fonomorfologıa','бірпартиялы' => 'birpartıaly','саяхатшылық' => 'saıahatshylyq','шалқаю' => 'shalqaıý','жеміссабақ' => 'jemissabaq','салғаннан' => 'salǵannan','топология' => 'topologıa','фаялит' => 'faıalıt','миллибар' => 'mıllıbar','асфальтит' => 'asfáltıt','сульфит' => 'súlfıt','атрофия' => 'atrofıa','итальян' => 'ıtalán','аяқтабақ' => 'aıaqtabaq','арахнология' => 'arahnologıa','саялау' => 'saıalaý','аффинация' => 'afınasıa','қаялы' => 'qaıaly','биметалл' => 'bımetal','қараю' => 'qaraıý','тавтология' => 'tavtologıa','түюсіз' => 'túıýsiz','окклюзия' => 'oklúzıa','голография' => 'golografıa','террариум' => 'terarıým','миллимикрон' => 'mıllımıkron','доссыну' => 'dossyný','қоянжел' => 'qoıanjel','гидрология' => 'gıdrologıa','джип' => 'jıp','биязы' => 'bıazy','иіссіз' => 'ıissiz','түртию' => 'túrtıý','субъект' => 'sýbekt','кіржию' => 'kirjıý','радиоаппарат' => 'radıoaparat','кекию' => 'kekıý','томпию' => 'tompıý','биоклиматология' => 'bıoklımatologıa','рейтинг' => 'reıtıń','қоқаю' => 'qoqaıý','сияқтану' => 'sıaqtaný','трагикомедия' => 'tragıkomedıa','тоқыраю' => 'toqyraıý','съезд' => 'sıez','қияқша' => 'qıaqsha','категория' => 'kategorıa','шұнтию' => 'shuntıý','кюрий' => 'kúrı','деформация' => 'deformasıa','қияқы' => 'qıaqy','сульфат' => 'súlfat','геосаяси' => 'geosaıası','ассоциациялану' => 'asosıasıalaný','ес-түссіз' => 'es-tússiz','экю' => 'ekú','экспозиция' => 'ekspozısıa','күю' => 'kúıý','гетерография' => 'geterografıa','бактериятану' => 'bakterıataný','қайрият' => 'qaırıat','микромаркетинг' => 'mıkromarketıń','акцессориялар' => 'aksesorıalar','имию' => 'ımıý','консервация' => 'konservasıa','зоологиялық' => 'zoologıalyq','тою' => 'toıý','гимназия' => 'gımnazıa','фюзеляж' => 'fúzeláj','полиметалл' => 'polımetal','грамм-моль' => 'gramm-mól','хиромантия' => 'hıromantıa','шолтаю' => 'sholtaıý','зияткер' => 'zıatker','технологиялық' => 'tehnologıalyq','радист' => 'radıs','корреспонденция' => 'korespondensıa','гравитация' => 'gravıtasıa','тығыл-таяң' => 'tyǵyl-taıań','метеорография' => 'meteorografıa','түксию' => 'túksıý','фолликулит' => 'folıkýlıt','шлюзді' => 'shlúzdi','отаю' => 'otaıý','шұқыраю' => 'shuqyraıý','радиогеология' => 'radıogeologıa','волейбол' => 'voleıbol','шоқаю' => 'shoqaıý','коалиция' => 'koalısıa','педикюр' => 'pedıkúr','магнитобиология' => 'magnıtobıologıa','пессимизм' => 'pesımızm','аяушылық' => 'aıaýshylyq','сәңкию' => 'sáńkıý','сөлбірею' => 'sólbireıý','аяулы' => 'aıaýly','ащылау' => 'ashshylaý','батиметрия' => 'batımetrıa','глосса' => 'glosa','даярлаулы' => 'daıarlaýly','стерлинг' => 'sterlıń','қалшию' => 'qalshıý','бояушы' => 'boıaýshy','авантюризм' => 'avantúrızm','үшаяқ' => 'úshaıaq','кегжию' => 'kegjıý','индукция' => 'ındýksıa','аяныштылық' => 'aıanyshtylyq','шоңқию' => 'shońqıý','госпиталь' => 'gospıtál','хиджаб' => 'hıdjab','бөліссіз' => 'bólissiz','барельеф' => 'barelef','борщ' => 'borsh','неотения' => 'neotenıa','миксобактерия' => 'mıksobakterıa','баяу' => 'baıaý','тұқыраю' => 'tuqyraıý','термохимиялық' => 'termohımıalyq','жымсию' => 'jymsıý','амфибия' => 'amfıbıa','аяқасты' => 'aıaqasty','фразеография' => 'frazeografıa','экзобиология' => 'ekzobıologıa','шөкию' => 'shókıý','эпистемиология' => 'epıstemıologıa','қайқаю' => 'qaıqaıý','рубль' => 'rúbl','демобилизация' => 'demobılızasıa','мещандық' => 'meshandyq','зарядты' => 'zarádti','эмбриология' => 'embrıologıa','гидрохимиялық' => 'gıdrohımıalyq','шатқаяқтау' => 'shatqaıaqtaý','қаңқию' => 'qańqıý','хикая' => 'hıkaıa','зарядтану' => 'zarádtaný','диверсиялық' => 'dıversıalyq','вольт' => 'vólt','реквизация' => 'rekvızasıa','педиатриялық' => 'pedıatrıalyq','шікірею' => 'shikireıý','голланд' => 'goland','баронесса' => 'baronesa','оппозиция' => 'opozısıa','адия' => 'adıa','бактериемия' => 'bakterıemıa','аммофос' => 'amofos','ағашаяқ' => 'aǵashaıaq','фолликул' => 'folıkýl','фонация' => 'fonasıa','ұядай' => 'uıadaı','велосапар' => 'velosapar','муссондық' => 'mýsondyq','қатаю' => 'qataıý','қашаннан' => 'qashannan','агроэкология' => 'agroekologıa','телетранслятор' => 'teletranslátor','таяздау' => 'taıazdaý','поляр' => 'polár','помещиктік' => 'pomeshıktik','архебактериялар' => 'arhebakterıalar','эмоция' => 'emosıa','вице-консул' => 'vıse-konsýl','гинекология' => 'gınekologıa','электркардиография' => 'elektrkardıografıa','стоматолог' => 'stomatolog','биостратиграфия' => 'bıostratıgrafıa','этимология' => 'etımologıa','саясатшы' => 'saıasatshy','шадияр' => 'shadıar','ванна' => 'vana','жарыссөз' => 'jaryssóz','демодулятор' => 'demodýlátor','антикоагулянт' => 'antıkoagýlánt','аюжылан' => 'aıýjylan','картограмма' => 'kartogram','обсерватория' => 'observatorıa','релятивті' => 'relátıvti','парфюмер' => 'parfúmer','медальон' => 'medalón','бруцеллез' => 'brýselez','эпидемиология' => 'epıdemıologıa','тұяқкесті' => 'tuıaqkesti','долларшыл' => 'dollarshyl','барокко' => 'baroko','ватт-сағат' => 'vatt-saǵat','саябыр' => 'saıabyr','профессура' => 'profesýra','метрология' => 'metrologıa','қиял-арман' => 'qıal-arman','экспроприация' => 'eksproprıasıa','фасилитация' => 'fasılıtasıa','қою' => 'qoıý','зияткерлік' => 'zıatkerlik','миллиард' => 'mıllıard','тасаяқ' => 'tasaıaq','токсиколог' => 'toksıkolog','паттисон' => 'patıson','мизантропия' => 'mızantropıa','мықыраю' => 'myqyraıý','диверсиялық-барлаушылық' => 'dıversıalyq-barlaýshylyq','химмитология' => 'hımıtologıa','саясаткер' => 'saıasatker','триллион' => 'trıllıon','коммивояжер' => 'komıvoıajer','биогеохимиялық' => 'bıogeohımıalyq','этимологиялық' => 'etımologıalyq','гибридология' => 'gıbrıdologıa','азаю' => 'azaıý','тотию' => 'totıý','аялдасу' => 'aıaldasý','шөлқияқ' => 'shólqıaq','галлюцинация' => 'galúsınasıa','летаргия' => 'letargıa','геометрия' => 'geometrıa','сомпию' => 'sompıý','бөгеліссіз' => 'bógelissiz','жымпию' => 'jympıý','радиолокация' => 'radıolokasıa','агрессияшылдық' => 'agresıashyldyq','қоссүзбелі' => 'qossúzbeli','аяқбаусыз' => 'aıaqbaýsyz','шақшыраю' => 'shaqshyraıý','висмутин' => 'vısmýtın','монолог' => 'monolog','амплиация' => 'amplıasıa','энзимология' => 'enzımologıa','диверсия' => 'dıversıa','баяулату' => 'baıaýlatý','реакция' => 'reaksıa','ұят' => 'uıat','отоскопия' => 'otoskopıa','акваланг' => 'akvalań','культивациялау' => 'kúltıvasıalaý','баяулатқыш' => 'baıaýlatqysh','хастеллой' => 'hasteloı','пальма' => 'pálma','автаркия' => 'avtarkıa','солбыраю' => 'solbyraıý','эссе' => 'esse','сая' => 'saıa','пропорциялы' => 'proporsıaly','жариялы' => 'jarıaly','аяқтай' => 'aıaqtaı','альт' => 'ált','теолог' => 'teolog','қилы-қиян' => 'qıly-qıan','микроманипулятор' => 'mıkromanıpýlátor','аббревиатура' => 'abrevıatýra','фотоэтюд' => 'fotoetúd','ренессанс' => 'renesans','авиациялық' => 'avıasıalyq','тақыссыз' => 'taqyssyz','аутомия' => 'aýtomıa','диск' => 'dısk','бағдар-баян' => 'baǵdar-baıan','астролог' => 'astrolog','монтию' => 'montıý','энтропия' => 'entropıa','қиюластыру' => 'qıýlastyrý','мұддаға' => 'muddaǵa','фортификация' => 'fortıfıkasıa','антенна' => 'antena','қызылмия' => 'qyzylmıa','қоссайыс' => 'qossaıys','аурикулярия' => 'aýrıkýlárıa','баяндамашы' => 'baıandamashy','қамыссырнай' => 'qamyssyrnaı','комиссар' => 'komısar','иллюстрациялық' => 'ılústrasıalyq','ландшафт' => 'landshaft','шемая' => 'shemaıa','рияшылдық' => 'rıashyldyq','фенолог' => 'fenolog','микропроцессор' => 'mıkroprosesor','аллопатрия' => 'alopatrıa','уәлаят' => 'ýálaıat','гортензия' => 'gortenzıa','меню' => 'menú','гвардия' => 'gvardıa','кекірею' => 'kekireıý','конспирация' => 'konspırasıa','аэрологиялық' => 'aerologıalyq','эксклюзивті' => 'eksklúzıvti','құрылымдық-металлогендік' => 'qurylymdyq-metalogendik','хост-компьютер' => 'host-kompúter','бульдозер' => 'búldozer','васкулит' => 'vaskýlıt','медпункт' => 'medpýnkt','инвестициялық' => 'ınvestısıalyq','бояғыш' => 'boıaǵysh','бұра-саяқ' => 'bura-saıaq','биогеографиялық' => 'bıogeografıalyq','қоянбеде' => 'qoıanbede','дауыссыз' => 'daýyssyz','тыюсыз' => 'tyıýsyz','перцепция' => 'persepsıa','саяхаттау' => 'saıahattaý','альдегид' => 'áldegıd','элюент' => 'elúent','комбинациялау' => 'kombınasıalaý','ықтияттау' => 'yqtıattaý','көзаяқ' => 'kózaıaq','экология' => 'ekologıa','сюзерен' => 'súzeren','джентльмен' => 'jentlmen','зиялылық' => 'zıalylyq','аллерген' => 'alergen','құпиялылық' => 'qupıalylyq','қия-қыр' => 'qıa-qyr','аялану' => 'aıalaný','мультипликация' => 'múltıplıkasıa','плюрализм' => 'plúralızm','аллергологиялық' => 'alergologıalyq','тіссіз' => 'tissiz','иммундық' => 'ımýndyq','вахта' => 'vahta','хикаялау' => 'hıkaıalaý','шәлтию' => 'sháltıý','ноя' => 'noıa','бюллетень' => 'búleten','ақаю' => 'aqaıý','трагедиялы' => 'tragedıaly','экспедиция' => 'ekspedısıa','орнитология' => 'ornıtologıa','трюфель' => 'trúfel','партияшыл' => 'partıashyl','хемосорбция' => 'hemosorbsıa','инфаркт' => 'ınfarkt','түксиюлі' => 'túksıýli','дефектологиялық' => 'defektologıalyq','морфологиялық' => 'morfologıalyq','бақа-шаян' => 'baqa-shaıan','аяң' => 'aıań','геохимия' => 'geohımıa','тюбинг' => 'túbıń','виза' => 'vıza','теңкию' => 'teńkıý','стратегия' => 'strategıa','мөлию' => 'mólıý','инерция' => 'ınersıa','бейкоммерциялық' => 'beıkomersıalyq','мифологиядай' => 'mıfologıadaı','тұяқсерпер' => 'tuıaqserper','торсию' => 'torsıý','барограмма' => 'barogram','бессаусақ' => 'bessaýsaq','диссонанс' => 'dısonans','лексикологиялық' => 'leksıkologıalyq','мия' => 'mıa','вадоз' => 'vadoz','бактериялану' => 'bakterıalaný','біздию' => 'bizdıý','бақшию' => 'baqshıý','ұятсыну' => 'uıatsyný','айылқияқ' => 'aıylqıaq','зияттық' => 'zıattyq','династия' => 'dınastıa','гастроэнтерология' => 'gastroenterologıa','асбест' => 'asbes','тікшию' => 'tikshıý','кірпияздану' => 'kirpıazdaný','аяқтандыру' => 'aıaqtandyrý','натурфилософиялық' => 'natýrfılosofıalyq','қаяулы' => 'qaıaýly','федерация' => 'federasıa','дариядай' => 'darıadaı','шұңқыраю' => 'shuńqyraıý','аллашыл' => 'allashyl','бауыраяқты' => 'baýyraıaqty','синестезия' => 'sınestezıa','позиция' => 'pozısıa','ұю' => 'uıý','территория' => 'terıtorıa','түп-тұқиян' => 'túp-tuqıan','жаюлы' => 'jaıýly','аянсақ' => 'aıansaq','мүдделі' => 'múddeli','контрибуция' => 'kontrıbýsıa','жаясыз' => 'jaıasyz','эндотермиялық' => 'endotermıalyq','археографиялық' => 'arheografıalyq','ашатұяқты' => 'ashatuıaqty','аббат' => 'abat','пирометаллургия' => 'pırometalýrgıa','сейсмография' => 'seısmografıa','тоннаж' => 'tonnaj','қоянжүн' => 'qoıanjún','аюжүнді' => 'aıýjúndi','шаңқию' => 'shańqıý','сүмсию' => 'súmsıý','қыржию' => 'qyrjıý','мықшию' => 'myqshıý','аммоний' => 'amonı','коммуналдық' => 'komýnaldyq','берилл' => 'berıl','қиял-ғажайып' => 'qıal-ǵajaıyp','большевик' => 'bólshevık','режиссуралық' => 'rejısýralyq','баттерфляй' => 'baterfláı','сый-сияпат' => 'syı-sıapat','баянжазба' => 'baıanjazba','боясу' => 'boıasý','құсария' => 'qusarıa','коряк' => 'korák','палеонтолог' => 'paleontolog','ассонанс' => 'asonans','биологиялық' => 'bıologıalyq','бояутозаңдатқыш' => 'boıaýtozańdatqysh','этиология' => 'etıologıa','ұятты' => 'uıatty','микромиллиметр' => 'mıkromıllımetr','бордюр' => 'bordúr','қояр-қоймастан' => 'qoıar-qoımastan','хрестоматия' => 'hrestomatıa','аңыраю' => 'ańyraıý','қолды-аяққа' => 'qoldy-aıaqqa','траншеялық' => 'transheıalyq','констатация' => 'konstatasıa','мүттакалам' => 'múttakalam','дуалист' => 'dýalıs','дивергенция' => 'dıvergensıa','рентгенограмма' => 'rentgenogram','ателье' => 'atele','князьдық' => 'knázdik','ваучер' => 'vaýcher','баротерапия' => 'baroterapıa','аялау' => 'aıalaý','осциллограф' => 'osılograf','аямпаздық' => 'aıampazdyq','драматургия' => 'dramatýrgıa','юань' => 'ıýán','бұдыраю' => 'budyraıý','шермию' => 'shermıý','саңыраю' => 'sańyraıý','аяншақтық' => 'aıanshaqtyq','иіссу' => 'ıissý','аякөз' => 'aıakóz','антологиялық' => 'antologıalyq','микрооперация' => 'mıkrooperasıa','едірею' => 'edireıý','тиянадай' => 'tıanadaı','десорбциялау' => 'desorbsıalaý','муляж' => 'mýláj','офтальмоскопия' => 'oftálmoskopıa','будда' => 'býdda','радиотерапия' => 'radıoterapıa','трилогия' => 'trılogıa','физиатрия' => 'fızıatrıa','маяна' => 'maıana','қияпас' => 'qıapas','жолаяқ' => 'jolaıaq','бактериология' => 'bakterıologıa','жанқиярлық' => 'janqıarlyq','шыныаяқ' => 'shynyaıaq','террористік' => 'terorıstik','ортопсихиатрия' => 'ortopsıhıatrıa','жыныссыз' => 'jynyssyz','ұялмай-қызармай' => 'uıalmaı-qyzarmaı','дифтонг' => 'dıftoń','металлофон' => 'metalofon','естиярлау' => 'estıarlaý','идеография' => 'ıdeografıa','таянышсыз' => 'taıanyshsyz','қойтұяқ' => 'qoıtuıaq','аян' => 'aıan','экспрессивті' => 'ekspresıvti','телефотография' => 'telefotografıa','диалектологиялық' => 'dıalektologıalyq','нармия' => 'narmıa','филантропия' => 'fılantropıa','баратрия' => 'baratrıa','продюсер' => 'prodúser','қонжию' => 'qonjıý','кекею' => 'kekeıý','идеясыз' => 'ıdeıasyz','азобояғыш' => 'azoboıaǵysh','бітию' => 'bitıý','тәштию' => 'táshtıý','калория' => 'kalorıa','бояту' => 'boıatý','ояу' => 'oıaý','боссораң' => 'bossorań','аяз' => 'aıaz','синхрониялық' => 'sınhronıalyq','радиостудия' => 'radıostýdıa','серею' => 'sereıý','бактерияжегі' => 'bakterıajegi','некеқияр' => 'nekeqıar','фракиялықтар' => 'frakıalyqtar','баю' => 'baıý','аккомпанемент' => 'akompanement','финн' => 'fın','актиния' => 'aktınıa','хартия' => 'hartıa','тіссауыт' => 'tissaýyt','саяздық' => 'saıazdyq','фантасмагория' => 'fantasmagorıa','бюджеттік' => 'búdjettik','медалист' => 'medalıs','қоянжоңышқа' => 'qoıanjońyshqa','руханият' => 'rýhanıat','дюшес' => 'dúshes','аллалау' => 'allalaý','диссертация' => 'dısertasıa','қияқшөп' => 'qıaqshóp','метеорология' => 'meteorologıa','агрометеорология' => 'agrometeorologıa','ноология' => 'noologıa','пейзажист' => 'peızajıs','фантазиялық' => 'fantazıalyq','бөріаяқ' => 'bóriaıaq','аппендицит' => 'apendısıt','сақсию' => 'saqsıý','аяқша' => 'aıaqsha','идеясыздық' => 'ıdeıasyzdyq','диффузиялық' => 'dıfýzıalyq','жағдаяттылық' => 'jaǵdaıattylyq','жағдаят' => 'jaǵdaıat','комментатор' => 'komentator','антибактериялық' => 'antıbakterıalyq','аятолла' => 'aıatolla','ревизионист' => 'revızıonıs','атты-жаяу' => 'atty-jaıaý','гиппопотам' => 'gıpopotam','гидрогеометрия' => 'gıdrogeometrıa','әдді' => 'áddi','онколог' => 'onkolog','шидию' => 'shıdıý','тонзиллит' => 'tonzılıt','фонологиялық' => 'fonologıalyq','баяндасу' => 'baıandasý','волюнтаристік' => 'volúntarıstik','соя' => 'soıa','вице-министр' => 'vıse-mınıstr','радиациялық' => 'radıasıalyq','эндогамия' => 'endogamıa','экспликация' => 'eksplıkasıa','сияқ' => 'sıaq','егессіз' => 'egessiz','энтомолог' => 'entomolog','глоссематика' => 'glosematıka','дипломатия' => 'dıplomatıa','яһуди' => 'ıahýdı','шықию' => 'shyqıý','сырию' => 'syrıý','литургиялық' => 'lıtýrgıalyq','агрометеорологиялық' => 'agrometeorologıalyq','буржуазиялық' => 'býrjýazıalyq','стрептококк' => 'streptokok','дыбыссыз' => 'dybyssyz','вестибулярлы' => 'vestıbýlárly','радиологиялық' => 'radıologıalyq','компрессор' => 'kompresor','сиялау' => 'sıalaý','асфальтен' => 'asfálten','пианист' => 'pıanıs','корректор' => 'korektor','мещан' => 'meshan','қомпию' => 'qompıý','моносиллабизм' => 'monosılabızm','абсолютшілдік' => 'absolútshildik','аэрофотоаппарат' => 'aerofotoaparat','біррангілі' => 'birrangili','эквилибрист' => 'ekvılıbrıs','хоккейші' => 'hokeıshi','френология' => 'frenologıa','микроклиматология' => 'mıkroklımatologıa','маялауыш' => 'maıalaýysh','шекию' => 'shekıý','прессинг' => 'presıń','ассимиляция' => 'asımılásıa','биолог' => 'bıolog','конъюнктивит' => 'konúnktıvıt','тілқияр' => 'tilqıar','тюямунит' => 'túıamýnıt','герцогиня' => 'gersogıná','баянсыз' => 'baıansyz','фальц' => 'fáls','мегатонна' => 'megatonna','қиянат' => 'qıanat','демаркация' => 'demarkasıa','элеутерококк' => 'eleýterokok','жалаңаяқ' => 'jalańaıaq','қосаяқтай' => 'qosaıaqtaı','қыңыраю' => 'qyńyraıý','вахталық' => 'vahtalyq','фальцет' => 'fálset','алааяқ' => 'alaaıaq','зиялы' => 'zıaly','дерматолог' => 'dermatolog','нутациялық' => 'nýtasıalyq','агрономия' => 'agronomıa','баяндалу' => 'baıandalý','альгеология' => 'álgeologıa','гипотермия' => 'gıpotermıa','қазақия' => 'qazaqıa','шаянмойын' => 'shaıanmoıyn','вандализм' => 'vandalızm','кержию' => 'kerjıý','түюлі' => 'túıýli','аяқүсті' => 'aıaqústi','тиянақсыз' => 'tıanaqsyz','тырсию' => 'tyrsıý','саябырсу' => 'saıabyrsý','яһудилік' => 'ıahýdılik','багги' => 'bagı','оятушы' => 'oıatýshy','инспекция' => 'ınspeksıa','аэрофототопография' => 'aerofototopografıa','ось' => 'ós','коэффициенттік' => 'koefısıenttik','аудиенция' => 'aýdıensıa','буддизм' => 'býddızm','акарология' => 'akarologıa','алласыз' => 'allasyz','санскритолог' => 'sanskrıtolog','оккультизм' => 'okúltızm','пневмококк' => 'pnevmokok','осциллографиялық' => 'osılografıalyq','радиация' => 'radıasıa','полигонометрия' => 'polıgonometrıa','интеграциялану' => 'ıntegrasıalaný','конденсация' => 'kondensasıa','кавалерия' => 'kavalerıa','парашютші' => 'parashútshi','сараджа' => 'saradja','хикаялы' => 'hıkaıaly','афазия' => 'afazıa','атаксия' => 'ataksıa','библиографиялық' => 'bıblıografıalyq','монополиясыздандыру' => 'monopolıasyzdandyrý','карбюратор' => 'karbúrator','ортаю' => 'ortaıý','фильмографиялық' => 'fılmografıalyq','ақшию' => 'aqshıý','релятивизм' => 'relátıvızm','лықию' => 'lyqıý','анаграмма' => 'anagram','градация' => 'gradasıa','терция' => 'tersıa','лимнология' => 'lımnologıa','қампию' => 'qampıý','альмандин' => 'álmandın','аннексия' => 'aneksıa','тойтию' => 'toıtıý','бая-шая' => 'baıa-shaıa','вариациялау' => 'varıasıalaý','туатаяқ' => 'týataıaq','процессор' => 'prosesor','география' => 'geografıa','палеогидрогеология' => 'paleogıdrogeologıa','спираль' => 'spırál','мұртаяқтылар' => 'murtaıaqtylar','құдая' => 'qudaıa','антипассат' => 'antıpasat','гидрометеоролог' => 'gıdrometeorolog','шотаяқ' => 'shotaıaq','фотографиялық' => 'fotografıalyq','корпорация' => 'korporasıa','полифониялық' => 'polıfonıalyq','құдды' => 'quddy','рияшыл' => 'rıashyl','дедукция' => 'dedýksıa','аяқшы' => 'aıaqshy','лицензиялау' => 'lısenzıalaý','құпия' => 'qupıa','бюрократтану' => 'búrokrattaný','шезлонг' => 'shezloń','минималист' => 'mınımalıs','этимолог' => 'etımolog','доллар' => 'dollar','психотерапия' => 'psıhoterapıa','факультет' => 'fakúltet','қоян-қолтықтасу' => 'qoıan-qoltyqtasý','антропология' => 'antropologıa','тоннадай' => 'tonnadaı','теократия' => 'teokratıa','фантаст' => 'fantas','таяқ' => 'taıaq','қияш' => 'qıash','даяшы' => 'daıashy','опыраю' => 'opyraıý','япыр-ау' => 'ıapyr-aý','орфографиялану' => 'orfografıalaný','липограмма' => 'lıpogram','биотелеметрия' => 'bıotelemetrıa','аяқбау' => 'aıaqbaý','мумиялау' => 'mýmıalaý','баланс-нетто' => 'balans-neto','алтын-валюта' => 'altyn-valúta','монотония' => 'monotonıa','ащылық' => 'ashshylyq','филолог' => 'fılolog','капиталист' => 'kapıtalıs','баттию' => 'battıý','жандармерия' => 'jandarmerıa','бутафория' => 'býtaforıa','инсаният' => 'ınsanıat','увертюра' => 'ývertúra','аккумуляттану' => 'akýmýláttaný','кещелік' => 'keshshelik','бояну' => 'boıaný','картографиялық' => 'kartografıalyq','вольтті' => 'vóltti','қиямпұрыстану' => 'qıampurystaný','шілбию' => 'shilbıý','аммофосшы' => 'amofosshy','кию' => 'kıý','алшаю' => 'alshaıý','гипонимия' => 'gıponımıa','ферромагнит' => 'feromagnıt','агробиологиялық' => 'agrobıologıalyq','итмия' => 'ıtmıa','космология' => 'kosmologıa','антикоммунистік' => 'antıkomýnıstik','компьютерлі' => 'kompúterli','аяқастынан' => 'aıaqastynan','агрохимиялық' => 'agrohımıalyq','фармаколог' => 'farmakolog','бүрсию' => 'búrsıý','биялай' => 'bıalaı','оюлау' => 'oıýlaý','қоянсүйек' => 'qoıansúıek','естиярлық' => 'estıarlyq','соқию' => 'soqıý','аяңдасу' => 'aıańdasý','лейборист' => 'leıborıs','супияз' => 'sýpıaz','габбро-порфирит' => 'gabro-porfırıt','ян' => 'ıan','проторенессанс' => 'protorenesans','ведомстволық' => 'vedimistik','іссіздік' => 'issizdik','арман-мүдде' => 'arman-múdde','романист' => 'romanıs','әйкелтаяқ' => 'áıkeltaıaq','миссия' => 'mısıa','жылмию' => 'jylmıý','декларация' => 'deklarasıa','фуксия' => 'fýksıa','иррационал' => 'ırasıonal','паразитолог' => 'parazıtolog','юра' => 'ıýra','баяулаңқырау' => 'baıaýlańqyraý','фонограмма' => 'fonogram','комедия' => 'komedıa','я' => 'ıa','модуляция' => 'modýlásıa','қосжұпаяқты' => 'qosjupaıaqty','ренессанстық' => 'renesanstyq','артикль' => 'artıkl','өңкию' => 'óńkıý','агрессияшыл' => 'agresıashyl','қылжию' => 'qyljıý','эколог' => 'ekolog','бұжыраю' => 'bujyraıý','фармация' => 'farmasıa','намыссыздық' => 'namyssyzdyq','баяулатыңқырау' => 'baıaýlatyńqyraý','буып-түю' => 'býyp-túıý','телепатия' => 'telepatıa','редупликация' => 'redýplıkasıa','вирустық' => 'vırýstyq','аннуитет' => 'anýıtet','астрология' => 'astrologıa','репатриация' => 'repatrıasıa','империя' => 'ımperıa','тарланқияқ' => 'tarlanqıaq','менеджмент' => 'menedjment','альгеологиялық' => 'álgeologıalyq','фототерапия' => 'fototerapıa','фарияд' => 'farıad','биосферология' => 'bıosferologıa','волюнтаризм' => 'volúntarızm','аллонж' => 'alonj','драматургиялық' => 'dramatýrgıalyq','тәбия' => 'tábıa','агглютинативтік' => 'aglútınatıvtik','әскери-стратегиялық' => 'áskerı-strategıalyq','новеллашы' => 'novelashy','джентльмендік' => 'jentlmendik','гаммарус' => 'gammarýs','ая' => 'aıa','оюлы' => 'oıýly','инкубациялық' => 'ınkýbasıalyq','топологиялық' => 'topologıalyq','демалыссыз' => 'demalyssyz','ыздию' => 'yzdıý','миллиампер' => 'mıllıamper','бағыныссыз' => 'baǵynyssyz','метатеория' => 'metateorıa','аяқтастыру' => 'aıaqtastyrý','аят-хадис' => 'aıat-hadıs','жал-жая' => 'jal-jaıa','суффикс' => 'sýfıks','аяғыштық' => 'aıaǵyshtyq','нығаю' => 'nyǵaıý','қоянжүзген' => 'qoıanjúzgen','психиатрия' => 'psıhıatrıa','әңгіртаяқ' => 'áńgirtaıaq','кеще' => 'keshshe','бауыраяқ' => 'baýyraıaq','тромб' => 'tromb','микрокалькулятор' => 'mıkrokalkýlátor','аккузатив' => 'akýzatıv','диюдай' => 'dıýdaı','оккупациялау' => 'okýpasıalaý','травматология' => 'travmatologıa','периферия' => 'perıferıa','баянды' => 'baıandy','шүңкию' => 'shúńkıý','декорация' => 'dekorasıa','вахмистр' => 'vahmıstr','таяныш' => 'taıanysh','суаяқ' => 'sýaıaq','тополог' => 'topolog','гимназист' => 'gımnazıs','сейсмолог' => 'seısmolog','филология' => 'fılologıa','конверсия' => 'konversıa','галлюцинациялық' => 'galúsınasıalyq','мұқият' => 'muqıat','зияратхана' => 'zıarathana','партиялас' => 'partıalas','аллерголог' => 'alergolog','терригендік' => 'terıgendik','сыю' => 'syıý','биогеоценология' => 'bıogeosenologıa','теллуридтер' => 'telýrıdter','интерференция' => 'ınterferensıa','энциклопедияшы' => 'ensıklopedıashy','штольня' => 'shtólná','коммерция' => 'komersıa','варяг' => 'varág','психологиялық' => 'psıhologıalyq','тайлы-таяқ' => 'taıly-taıaq','оятқыш' => 'oıatqysh','қоссырнай' => 'qossyrnaı','эмпатия' => 'empatıa','апатиялық' => 'apatıalyq','ұялу' => 'uıalý','аккумуляция' => 'akýmýlásıa','барщина' => 'barshına','бақшыраю' => 'baqshyraıý','каюта' => 'kaıýta','қаужию' => 'qaýjıý','терренкур' => 'terenkýr','жербояу' => 'jerboıaý','хашия' => 'hashıa','бутафориялық' => 'býtaforıalyq','тексеріссіз' => 'tekserissiz','томарқияқ' => 'tomarqıaq','қияр' => 'qıar','дүрбию' => 'dúrbıý','орнитолог' => 'ornıtolog','коттедж' => 'kotej','геоэкология' => 'geoekologıa','пиязшөп' => 'pıazshóp','маддұға' => 'madduǵa','траншея' => 'transheıa','анестезиология' => 'anestezıologıa','снаряд' => 'snarád','қояншөп' => 'qoıanshóp','гольф' => 'gólf','субординация' => 'sýbordınasıa','антология' => 'antologıa','нақлият' => 'naqlıat','миятсыз' => 'mıatsyz','валенттік' => 'valenttik','релятивистік' => 'relátıvıstik','джиу-джитсу' => 'jıý-jıtsý','ұят-намыс' => 'uıat-namys','анафилаксия' => 'anafılaksıa','конденсациялық' => 'kondensasıalyq','тырқию' => 'tyrqıý','вотум' => 'votým','жарбию' => 'jarbıý','ыдыс-аяқ' => 'ydys-aıaq','іссапар' => 'issapar','фальстарт' => 'fálstart','тояттану' => 'toıattaný','термотерапия' => 'termoterapıa','текстология' => 'tekstologıa','зым-зия' => 'zym-zıa','декларациялық' => 'deklarasıalyq','ұяшық' => 'uıashyq','тайқию' => 'taıqıý','транслитерация' => 'translıterasıa','жаяусоқпақ' => 'jaıaýsoqpaq','түксірею' => 'túksireıý','ассоциациялық' => 'asosıasıalyq','пиязшық' => 'pıazshyq','уағалайкүмассалам' => 'ýaǵalaıkúmassalam','параллелепипед' => 'paralelepıped','дендролог' => 'dendrolog','әлейкүмассалам' => 'áleıkúmassalam','вискоза' => 'vıskoza','жаннаттай' => 'jannattaı','маймию' => 'maımıý','қоянерін' => 'qoıanerin','мониторинг' => 'monıtorıń','магнитологиялық' => 'magnıtologıalyq','дырдию' => 'dyrdıý','аянпаз' => 'aıanpaz','вице-адмирал' => 'vıse-admıral','тоғаю' => 'toǵaıý','жезтұяқ' => 'jeztuıaq','аяр' => 'aıar','шүю' => 'shúıý','объектілік' => 'obektilik','топографиялық' => 'topografıalyq','намыссыз' => 'namyssyz','конфессиялы' => 'konfesıaly','валериан' => 'valerıan','қосжұпаяқтылар' => 'qosjupaıaqtylar','хронологиялық' => 'hronologıalyq','блюминг' => 'blúmıń','бурят' => 'býrát','вегетативтік' => 'vegetatıvtik','үшаяқты' => 'úshaıaqty','баялыш' => 'baıalysh','монотеист' => 'monoteıs','идеялылық' => 'ıdeıalylyq','бағжию' => 'baǵjıý','таяуда' => 'taıaýda','қояншық' => 'qoıanshyq','жаяужол' => 'jaıaýjol','фьючерс' => 'fúchers','киноэпопея' => 'kınoepopeıa','бедірею' => 'bedireıý','пресс-атташе' => 'pres-atashe','дактилология' => 'daktılologıa','уезд' => 'ýez','миологиялық' => 'mıologıalyq','ювенильді' => 'ıývenıldi','ысқаяқ' => 'ysqaıaq','сеньор' => 'senor','мүддегер' => 'múddeger','графиня' => 'grafınıa','боямашылық' => 'boıamashylyq','гуляш' => 'gýlásh','ұялту' => 'uıaltý','аю' => 'aıý','палеоклиматология' => 'paleoklımatologıa','милленаризм' => 'mılenarızm','маялату' => 'maıalatý','педагог' => 'pedagog','волейболшы' => 'voleıbolshy','қырып-жою' => 'qyryp-joıý','эллипсоид' => 'elıpsoıd','килограмм-күш' => 'kılogram-kúsh','ақпатаяқ' => 'aqpataıaq','велотрек' => 'velotrek','пассаж' => 'pasaj','қаратұяқ' => 'qaratuıaq','дискриминациялау' => 'dıskrımınasıalaý','билливердин' => 'bılıverdın','геометриялау' => 'geometrıalaý','қыжыраю' => 'qyjyraıý','радиоспектроскопия' => 'radıospektroskopıa','консалтинг' => 'konsaltıń','габбро' => 'gabro','қаюбіз' => 'qaıýbiz','хронология' => 'hronologıa','аллитерация' => 'alıterasıa','лемма' => 'lema','грамм-эквивалент' => 'gram-ekvıvalent','комментарий' => 'komentarı','якудза' => 'ıakýdza','акцентуация' => 'aksentýasıa','беллетристика' => 'beletrıstıka','шөмию' => 'shómıý','алыссыну' => 'alyssyný','баллистикалық' => 'balıstıkalyq','қоянжын' => 'qoıanjyn','электрметаллургия' => 'elektrmetalýrgıa','томпаю' => 'tompaıý','эндокринолог' => 'endokrınolog','антропологиялық' => 'antropologıalyq','экотехнология' => 'ekotehnologıa','князь' => 'knáz','геохимиялық' => 'geohımıalyq','айрию' => 'aırıý','сілею' => 'sileıý','базофилия' => 'bazofılıa','велодром' => 'velodrom','эллипс' => 'elıps','үббе' => 'úbbe','трапеция' => 'trapesıa','невропатология' => 'nevropatologıa','жаялы' => 'jaıaly','орфографиялық' => 'orfografıalyq','қоссайысшы' => 'qossaıysshy','гидрогеохимия' => 'gıdrogeohımıa','агробиология' => 'agrobıologıa','корпорациялық' => 'korporasıalyq','аннуитант' => 'anýıtant','әсия' => 'ásıa','баяндаушылық' => 'baıandaýshylyq','сүмірею' => 'súmireıý','облигация' => 'oblıgasıa','зиянкес' => 'zıankes','биотермиялық' => 'bıotermıalyq','ықылассыз' => 'yqylassyz','сценарий' => 'senarı','сессия' => 'sesıa','аттик' => 'atık','урбаэкология' => 'ýrbaekologıa','пәсею' => 'páseıý','судья' => 'sýdıa','сақаю' => 'saqaıý','пиджак' => 'pıdjak','электркардиостимулятор' => 'elektrkardıostımýlátor','оят' => 'oıat','боялу' => 'boıalý','космогониялық' => 'kosmogonıalyq','капсюль' => 'kapsúl','аюдайын' => 'aıýdaıyn','аяншақ' => 'aıanshaq','дүңкию' => 'dúńkıý','эпилог' => 'epılog','целлулоид' => 'selýloıd','ащылы-тұщылы' => 'ashshyly-tushshyly','тетания' => 'tetanıa','сленг' => 'sleng','айыртұяқты' => 'aıyrtuıaqty','металграфиялық' => 'metalgrafıalyq','биология' => 'bıologıa','аннал' => 'anal','бейнедиск' => 'beınedısk','гидрометеорологиялық' => 'gıdrometeorologıalyq','оятқызу' => 'oıatqyzý','баялды' => 'baıaldy','басаяқтылар' => 'basaıaqtylar','фланг' => 'flań','идеялық' => 'ıdeıalyq','лифт' => 'lıft','заряд' => 'zarád','жариялатқызу' => 'jarıalatqyzý','дікию' => 'dikıý','манифест' => 'manıfes','шоқыраю' => 'shoqyraıý','бериллий' => 'berılı','жариялау' => 'jarıalaý','үрпию' => 'úrpıý','макроэнергиялық' => 'makroenergıalyq','иммиграция' => 'ımıgrasıa','терапия' => 'terapıa','эмульгатор' => 'emúlgator','параллелограмм' => 'paralelogram','антициопатия' => 'antısıopatıa','нейропсихиатрия' => 'neıropsıhıatrıa','қыртию' => 'qyrtıý','ілбию' => 'ilbıý','митинг' => 'mıtıń','антипатия' => 'antıpatıa','ирониялық' => 'ıronıalyq','грация' => 'grasıa','бүксию' => 'búksıý','факультатив' => 'fakúltatıv','көркею' => 'kórkeıý','вариациялық' => 'varıasıalyq','эмоциялық' => 'emosıalyq','вирусология' => 'vırýsologıa','делдию' => 'deldıý','гамма-тәсілдер' => 'gamma-tásilder','тыржию' => 'tyrjıý','саммит' => 'samıt','сарымия' => 'sarymıa','құярлық' => 'quıarlyq','шоссе' => 'shose','акцентуациялық' => 'aksentýasıalyq','кавалериялық' => 'kavalerıalyq','демаркетинг' => 'demarketıń','қия-шың' => 'qıa-shyń','вербалдану' => 'verbaldaný','редакциялық' => 'redaksıalyq','миллион' => 'mıllıon','телефония' => 'telefonıa','есею' => 'eseıý','эсхатология' => 'esqatologıa','аннигиляция' => 'anıgılásıa','мустанг' => 'mýstań','палинология' => 'palınologıa','эндемия' => 'endemıa','өң-түссіз' => 'óń-tússiz','демография' => 'demografıa','паяпарлану' => 'paıaparlaný','оппортунист' => 'oportýnıs','ащы-тұщы' => 'ashshy-tushshy','винегрет' => 'vınegret','кюритерапия' => 'kúrıterapıa','коммуникативтілік' => 'komýnıkatıvtilik','баянхат' => 'baıanhat','валентті' => 'valentti','байланыссыз' => 'baılanyssyz','аполлон' => 'apolon','рельеф' => 'relef','дозиметриялық' => 'dozımetrıalyq','аятулкүрсі' => 'aıatýlkúrsi','тобанаяқ' => 'tobanaıaq','апелляциялық' => 'apelásıalyq','славянтану' => 'slavántaný','вакуум' => 'vakým','жылмыраю' => 'jylmyraıý','вассал' => 'vasal','эксгумация' => 'eksgýmasıa','тояттау' => 'toıattaý','стенографист' => 'stenografıs','молаю' => 'molaıý','эллипсис' => 'elıpsıs','хронограмма' => 'hronogram','табыссыз' => 'tabyssyz','компания' => 'kompanıa','кинематография' => 'kınematografıa','бояухана' => 'boıaýhana','дактилография' => 'daktılografıa','конгресс' => 'kongres','угро-финн' => 'ýgro-fın','мультфильм' => 'múltfılm','әпірею' => 'ápireıý','жаяулық' => 'jaıaýlyq','телекоммуникация' => 'telekomýnıkasıa','үнжариялық' => 'únjarıalyq','форфейтинг' => 'forfeıtıń','миграциялық' => 'mıgrasıalyq','мұртаяқты' => 'murtaıaqty','саяқтау' => 'saıaqtaý','кооперация' => 'kooperasıa','гемограмма' => 'gemogram','тыңқию' => 'tyńqıý','ометр' => 'ometr','модернизациялау' => 'modernızasıalaý','кинобюллетень' => 'kınobúleten','лейб-гвардия' => 'leıb-gvardıa','валин' => 'valın','аммонит' => 'amonıt','ұзыннан-ұзақ' => 'uzynnan-uzaq','вокализ' => 'vokalız','гинекологиялық' => 'gınekologıalyq','бюрократ' => 'búrokrat','бағбию' => 'baǵbıý','валюталық' => 'valútalyq','барьер' => 'barer','глоттология' => 'glotologıa','маңқию' => 'mańqıý','монофилия' => 'monofılıa','даярлаушы' => 'daıarlaýshy','тақия' => 'taqıa','плазмолемма' => 'plazmolem','схоласт' => 'sholas','полярлық' => 'polárlik','палеонтологиялық' => 'paleontologıalyq','вакуумөлшеуіш' => 'vakýmólsheýish','саяжай' => 'saıajaı','пафоссыз' => 'pafossyz','әлқисса' => 'álqıssa','пародиялық' => 'parodıalyq','баянат' => 'baıanat','табыссыздық' => 'tabyssyzdyq','циркуль' => 'sırkúl','кальций' => 'kálsı','ищай' => 'ıshshaı','виолончелист' => 'vıolonchelıs','жаялық' => 'jaıalyq','эвакуация' => 'evakýasıa','жылтию' => 'jyltıý','зымиян' => 'zymıan','амортизациялық' => 'amortızasıalyq','электркоагуляция' => 'elektrkoagýlásıa','мияулау' => 'mıaýlaý','тұщыту' => 'tushshytý','сығыраю' => 'syǵyraıý','премьера' => 'premera','акваметрия' => 'akvametrıa','буынаяқтылар' => 'býynaıaqtylar','ономасиологиялық' => 'onomasıologıalyq','идея' => 'ıdeıa','аэрономия' => 'aeronomıa','тұқым-тұяқ' => 'tuqym-tuıaq','сүю' => 'súıý','идеалист' => 'ıdealıs','факт' => 'fakt','композиция' => 'kompozısıa','оясыздық' => 'oıasyzdyq','аяздату' => 'aıazdatý','беннеттит' => 'benetıt','қоянжұт' => 'qoıanjut','аңқию' => 'ańqıý','корреспондент' => 'korespondent','гликемия' => 'glıkemıa','көкаяздану' => 'kókaıazdaný','яғни' => 'ıaǵnı','психология' => 'psıhologıa','аянышты' => 'aıanyshty','филармониялық' => 'fılarmonıalyq','тосыраю' => 'tosyraıý','инвестиция' => 'ınvestısıa','сәйкессіздік' => 'sáıkessizdik','эпизоотия' => 'epızootıa','лизинг' => 'lızıń','ассоциация' => 'asosıasıa','ықтиярлық' => 'yqtıarlyq','гидробиолог' => 'gıdrobıolog','жеміссағақ' => 'jemissaǵaq','шиллинг' => 'shılıń','баяулану' => 'baıaýlaný','армресслинг' => 'armreslıń','жымыраю' => 'jymyraıý','монополиялық' => 'monopolıalyq','асфальт' => 'asfált','арабист' => 'arabıs','арпамәдиян' => 'arpamádıan','ортопедиялық' => 'ortopedıalyq','акция' => 'aksıa','яшма' => 'ıashma','аппендикулярия' => 'apendıkýlárıa','барщиналық' => 'barshınalyq','монархия' => 'monarhıa','буржуазияшыл' => 'býrjýazıashyl','аябақ' => 'aıabaq','биогеохимия' => 'bıogeohımıa','көппартиялық' => 'kóppartıalyq','азиялықша' => 'azıalyqsha','оттоманизм' => 'otomanızm','мотофелюга' => 'motofelúga','текстологиялық' => 'tekstologıalyq','тымпию' => 'tympıý','теософия' => 'teosofıa','прогрессивті' => 'progresıvti','ілмию' => 'ilmıý','даярласу' => 'daıarlasý','индукциялық' => 'ındýksıalyq','қаудию' => 'qaýdıý','фантазиялау' => 'fantazıalaý','комедиялық' => 'komedıalyq','нутация' => 'nýtasıa','глоттохронология' => 'glotohronologıa','бауыраяқтылар' => 'baýyraıaqtylar','әбият' => 'ábıat','айбатмия' => 'aıbatmıa','ферромагниттілік' => 'feromagnıttilik','сәйкессіз' => 'sáıkessiz','хикаяшыл' => 'hıkaıashyl','жию' => 'jıý','саяси' => 'saıası','ықтиятсыз' => 'yqtıatsyz','миллиграмм' => 'mıllıgram','тиянақталу' => 'tıanaqtalý','тақиятастам' => 'taqıatastam','листинг' => 'lıstıń','аяқ-басы' => 'aıaq-basy','ядро' => 'ıadro','рауаят' => 'raýaıat','шақшию' => 'shaqshıý','вариация' => 'varıasıa','баррикадалау' => 'barıkadalaý','мелшию' => 'melshıý','баяндандыру' => 'baıandandyrý','ояттыру' => 'oıattyrý','эвакуациялық' => 'evakýasıalyq','құршаян' => 'qurshaıan','рецидивист' => 'resıdıvıs','шүршию' => 'shúrshıý','телеметрия' => 'telemetrıa','юнкер' => 'ıýnker','аллотроптық' => 'alotroptyq','парапсихология' => 'parapsıhologıa','анатомиялық' => 'anatomıalyq','коммунизм' => 'komýnızm','жалпию' => 'jalpıý','бассыздық' => 'bassyzdyq','миллиметрлік' => 'mıllımetrlik','миграция' => 'mıgrasıa','шелтірею' => 'sheltireıý','пурист' => 'pýrıs','шлюздеу' => 'shlúzdeý','грильяж' => 'grıláj','делегация' => 'delegasıa','бейсаясат' => 'beısaıasat','стратегиялық' => 'strategıalyq','абсорбция' => 'absorbsıa','ассистенттік' => 'asıstenttik','қияли' => 'qıalı','геосаясаткер' => 'geosaıasatker','буынаяқты' => 'býynaıaqty','түссіздік' => 'tússizdik','аллофон' => 'alofon','жиюлы' => 'jıýly','ащыландыру' => 'ashshylandyrý','паразитология' => 'parazıtologıa','микропроцессорлық' => 'mıkroprosesorlyq','агломерациялық' => 'aglomerasıalyq','капитуляция' => 'kapıtýlásıa','ингаляция' => 'ıngalásıa','конфессиялық' => 'konfesıalyq','философия' => 'fılosofıa','технократия' => 'tehnokratıa','қиқоя' => 'qıqoıa','конституциялық' => 'konstıtýsıalyq','жұмыссыздық' => 'jumyssyzdyq','лобия' => 'lobıa','мүдіріссіз' => 'múdirissiz','бактериялық' => 'bakterıalyq','балпию' => 'balpıý','аэрология' => 'aerologıa','шелию' => 'shelıý','геронтократия' => 'gerontokratıa','аябоз' => 'aıaboz','картография' => 'kartografıa','шаңқаю' => 'shańqaıý','саю' => 'saıý','гвардиялық' => 'gvardıalyq','метролог' => 'metrolog','аяққұйрықтылар' => 'aıaqquıryqtylar','махаббатшыл' => 'mahabbatshyl','инкассатор' => 'ınkasator','құржию' => 'qurjıý','гравюра' => 'gravúra','аккорд' => 'akord','сабаяқ' => 'sabaıaq','ацидафиль' => 'asıdafıl','кекжию' => 'kekjıý','аялсыз' => 'aıalsyz','сылқию' => 'sylqıý','аппаратшы' => 'aparatshy','артиллерияшы' => 'artılerıashy','боямалық' => 'boıamalyq','альвеококк' => 'alveokok','қияқ' => 'qıaq','гирудотерапия' => 'gırýdoterapıa','гомогамиялық' => 'gomogamıalyq','миология' => 'mıologıa','қаяушы' => 'qaıaýshy','отқақұяр' => 'otqaquıar','боянып-тарану' => 'boıanyp-taraný','күшею' => 'kúsheıý','вульфенит' => 'vúlfenıt','саябақ' => 'saıabaq','лактация' => 'laktasıa','рояльшы' => 'roıálshi','атеист' => 'ateıs','еңкею' => 'eńkeıý','ғидда' => 'ǵıdda','саптаяқтай' => 'saptaıaqtaı','микроспоридия' => 'mıkrosporıdıa','виски' => 'vıskı','шылқию' => 'shylqıý','протозоология' => 'protozoologıa','келтию' => 'keltıý','аминопласт' => 'amınoplas','импульс' => 'ımpúls','кілмию' => 'kilmıý','тиянақтану' => 'tıanaqtaný','батальон' => 'batalón','рация' => 'rasıa','морфометриялық' => 'morfometrıalyq','комиссиялық' => 'komısıalyq','террикон' => 'terıkon','ысқаяқтану' => 'ysqaıaqtaný','акварель' => 'akvarel','тиуроцилл' => 'tıýrosıl','экологиялық' => 'ekologıalyq','аянкес' => 'aıankes','технофобия' => 'tehnofobıa','ессіз-түссіз' => 'essiz-tússiz','бридж' => 'brıj','гравиметрия' => 'gravımetrıa','қоңқаю' => 'qońqaıý','телевизия' => 'televızıa','репатриациялау' => 'repatrıasıalaý','тальк' => 'tálk','адъютант' => 'adútant','конвенция' => 'konvensıa','демобилизациялау' => 'demobılızasıalaý','бюджет' => 'búdjet','ар-ұят' => 'ar-uıat','люминесценттік' => 'lúmınesenttik','орангутанг' => 'orangýtań','жалынып-жалпаю' => 'jalynyp-jalpaıý','утопия' => 'ýtopıa','бюро' => 'búro','экзогамия' => 'ekzogamıa','натурфилософия' => 'natýrfılosofıa','биоэкология' => 'bıoekologıa','желаяқ' => 'jelaıaq','конденсациялау' => 'kondensasıalaý','саяз' => 'saıaz','колледж' => 'kolej','мұрат-мүдде' => 'murat-múdde','күннен-күнге' => 'kúnnen-kúnge','аудитория' => 'aýdıtorıa','аяныш' => 'aıanysh','палеозоологиялық' => 'paleozoologıalyq','итию' => 'ıtıý','териология' => 'terıologıa','фациялық' => 'fasıalyq','қияңқы' => 'qıańqy','глиссандо' => 'glısando','ықтиярлы' => 'yqtıarly','ассигнация' => 'asıgnasıa','экстрадация' => 'ekstradasıa','жуассыну' => 'jýassyný','юнга' => 'ıýnga','анархист' => 'anarhıs','бассыз' => 'bassyz','кумулятивтік' => 'kýmýlátıvtik','гидрография' => 'gıdrografıa','қозапая' => 'qozapaıa','аяңдау' => 'aıańdaý','дая' => 'daıa','телеобъектив' => 'teleobektıv','портьера' => 'portera','мантия' => 'mantıa','оястау' => 'oıastaý','грамматикалық' => 'gramatıkalyq','прапорщик' => 'praporshık','активист' => 'aktıvıs','тюбингілік' => 'túbıńgilik','саяткерлік' => 'saıatkerlik','лексикология' => 'leksıkologıa','тарбию' => 'tarbıý','эконометрия' => 'ekonometrıa','нияз' => 'nıaz','полисемия' => 'polısemıa','металлургиялық' => 'metalýrgıalyq','вокабула' => 'vokabýla','габбро-амфиболит' => 'gabro-amfıbolıt','бегония' => 'begonıa','иммигрант' => 'ımıgrant','иллюстрация' => 'ılústrasıa','парфюмериялық' => 'parfúmerıalyq','лосьон' => 'losón','күмпию' => 'kúmpıý','бинокулярлық' => 'bınokýlárlyq','бартию' => 'bartıý','культивациялық' => 'kúltıvasıalyq','миниатюра' => 'mınıatúra','мифолог' => 'mıfolog','пассивтік' => 'pasıvtik','реформация' => 'reformasıa','вольфрам' => 'vólfram','велошабандоз' => 'veloshabandoz','іссіз' => 'issiz','тұщытқыш' => 'tushshytqysh','аяқарба' => 'aıaqarba','саябырлану' => 'saıabyrlaný','идеология' => 'ıdeologıa','сояулану' => 'soıaýlaný','монополия' => 'monopolıa','граммофон' => 'gramofon','болбию' => 'bolbıý','синонимиялық' => 'sınonımıalyq','геронтология' => 'gerontologıa','утопист' => 'ýtopıs','вексельдік' => 'vekseldik','үзіліссіз' => 'úzilissiz','презумпция' => 'prezýmpsıa','аяқты' => 'aıaqty','бұлтарыссыз' => 'bultaryssyz','қушию' => 'qýshıý','разрядтауыш' => 'razrádteýish','вольттік' => 'vólttik','кейіннен' => 'keıinnen','қоянтамақ' => 'qoıantamaq','армян' => 'armán','вафли' => 'vaflı','океанология' => 'okeanologıa','апатия' => 'apatıa','құсаяқ' => 'qusaıaq','френолог' => 'frenolog','кардиолог' => 'kardıolog','шекшию' => 'shekshıý','дактилоскопия' => 'daktıloskopıa','валорлану' => 'valorlaný','энциклопедиялық' => 'ensıklopedıalyq','номография' => 'nomografıa','альтиметр' => 'áltımetr','ротация' => 'rotasıa','аялдаттыру' => 'aıaldattyrý','биолокация' => 'bıolokasıa','басаяқты' => 'basaıaqty','коммутатор' => 'komýtator','палеогидрогеологиялық' => 'paleogıdrogeologıalyq','аналогия' => 'analogıa','трюм' => 'trúm','училищелік' => 'ýchılıshelik','сопию' => 'sopıý','иықаяқты' => 'ıyqaıaqty','қорбию' => 'qorbıý','бояулану' => 'boıaýlaný','урбанизация' => 'ýrbanızasıa','палеогляциология' => 'paleoglásıologıa','бальнеологиялық' => 'bálneologıalyq','аяқтату' => 'aıaqtatý','венгр' => 'vengr','шиншилла' => 'shınshıla','баяуырақ' => 'baıaýyraq','гибридологиялық' => 'gıbrıdologıalyq','эврифагия' => 'evrıfagıa','афония' => 'afonıa','гектоватт-сағат' => 'gektovatt-saǵat','финн-угор' => 'fın-ýgor','навигациялық' => 'navıgasıalyq','диффузор' => 'dıfýzor','археологиялық' => 'arheologıalyq','аяздану' => 'aıazdaný','бейпартиялық' => 'beıpartıalyq','қарынаяқ' => 'qarynaıaq','жарияшы' => 'jarıashy','батааяқ' => 'bataaıaq','кердию' => 'kerdıý','сүйек-саяқ' => 'súıek-saıaq','модернизация' => 'modernızasıa','микрокомпьютер' => 'mıkrokompúter','лауэграмма' => 'laýegram','картридж' => 'kartrıj','волюнтативтік' => 'volúntatıvtik','қылқию' => 'qylqıý','телевизиялық' => 'televızıalyq','автоаялдама' => 'avtoaıaldama','тұғжию' => 'tuǵjıý','травматолог' => 'travmatolog','абстракция' => 'abstraksıa','гипертониялық' => 'gıpertonıalyq','коррозия' => 'korozıa','вакуумдық' => 'vakýmdyq','телескопия' => 'teleskopıa','тостию' => 'tostıý','химиялық' => 'hımıalyq','алтаяқ' => 'altaıaq','вице-премьер' => 'vıse-premer','аллегро' => 'alegro','ұяттау' => 'uıattaý','аллохтон' => 'alohton','рецензиялау' => 'resenzıalaý','ватт-метр' => 'vatt-metr','көкшию' => 'kókshıý','бюрократиясыздандыру' => 'búrokratıasyzdandyrý','аяздау' => 'aıazdaý','пиктографиялық' => 'pıktografıalyq','оппортунистік' => 'oportýnıstik','хоккей' => 'hokeı','қаяр' => 'qaıar','тотияйын' => 'totıaıyn','көзбояушы' => 'kózboıaýshy','қия' => 'qıa','төстию' => 'tóstıý','түйін-компьютер' => 'túıin-kompúter','әскери-демократиялық' => 'áskerı-demokratıalyq','қоржию' => 'qorjıý','пияз' => 'pıaz','көппартиялы' => 'kóppartıaly','ұлғаю' => 'ulǵaıý','саяжол' => 'saıajol','демагогиялық' => 'demagogıalyq','аппараттық' => 'aparattyq','сарысояу' => 'sarysoıaý','қиян-кескі' => 'qıan-keski','балласт' => 'balas','археолог' => 'arheolog','ұялы' => 'uıaly','термоядролық' => 'termoıadrolyq','долларлық' => 'dollarlyq','патология' => 'patologıa','баррель' => 'barel','туыссырау' => 'týyssyraý','тегіннен-тегін' => 'teginnen-tegin','флокуляция' => 'flokýlásıa','экстраполяция' => 'ekstrapolásıa','брутто' => 'brýtto','мумия' => 'mýmıa','қиядай' => 'qıadaı','эволюциялық' => 'evolúsıalyq','ербию' => 'erbıý','тызғаяқтық' => 'tyzǵaıaqtyq','базидиялы' => 'bazıdıaly','агглютинативті' => 'aglútınatıvti','филокартист' => 'fılokartıs','термокарст' => 'termokars','ыдыссалғыш' => 'ydyssalǵysh','макропсия' => 'makropsıa','бельтинг' => 'beltıń','дедукциялау' => 'dedýksıalaý','конференция' => 'konferensıa','лоббистік' => 'lobıstik','әдиял' => 'ádıal','физиолог' => 'fızıolog','санкция' => 'sanksıa','повесть' => 'poves','фракциялық' => 'fraksıalyq','филлиттену' => 'fılıttený','ою-өрнек' => 'oıý-órnek','пневмония' => 'pnevmonıa','партиясыз' => 'partıasyz','нейропсихология' => 'neıropsıhologıa','үюлі' => 'úıýli','бояу' => 'boıaý','пацифист' => 'pasıfıs','мышьяк' => 'myshák','шойқию' => 'shoıqıý','сюрреалист' => 'súrealıs','қиябет' => 'qıabet','ұзаю' => 'uzaıý','модельер' => 'modeler','геохронология' => 'geohronologıa','хроматография' => 'hromatografıa','резервация' => 'rezervasıa','баяндама' => 'baıandama','фонометрия' => 'fonometrıa','иррационализм' => 'ırasıonalızm','операцияаралық' => 'operasıaaralyq','аджар' => 'adjar','эпопея' => 'epopeıa','аяқтоғыз' => 'aıaqtoǵyz','бадиян' => 'badıan','тымыраю' => 'tymyraıý','дендрология' => 'dendrologıa','офтальмия' => 'oftálmıa','адыраю' => 'adyraıý','аюша' => 'aıýsha','шойқаю' => 'shoıqaıý','вестерндену' => 'vesterndený','вариант' => 'varıant','иіссабын' => 'ıissabyn','конфигурация' => 'konfıgýrasıa','датаграмма' => 'datagram','фагоцителлотәрізділер' => 'fagosıtelotárizdiler','шолтию' => 'sholtıý','вайербарс' => 'vaıerbars','неоцеребеллум' => 'neoserebelým','шодыраю' => 'shodyraıý','гомогамия' => 'gomogamıa','моногамия' => 'monogamıa','сұм-сұрқия' => 'sum-surqıa','калькуляциялық' => 'kálkýlásıalyq','миллиондық' => 'mıllıondyq','онкология' => 'onkologıa','теогония' => 'teogonıa','рецензия' => 'resenzıa','редакциялану' => 'redaksıalaný','әския' => 'áskıa','циркуляр' => 'sırkýlár','латифундист' => 'latıfýndıs','қиярбалық' => 'qıarbalyq','бояма' => 'boıama','юзанс' => 'ıýzans','гематология' => 'gematologıa','бассүйектану' => 'bassúıektaný','шатқаяқтату' => 'shatqaıaqtatý','бюрократтық' => 'búrokrattyq','функция' => 'fýnksıa','уролог' => 'ýrolog','кампания' => 'kampanıa','мұң-мүдде' => 'muń-múdde','синонимия' => 'sınonımıa','мияткер' => 'mıatker','иықаяқтылар' => 'ıyqaıaqtylar','гевея' => 'geveıa','летаргиялық' => 'letargıalyq','дискриминациялық' => 'dıskrımınasıalyq','тиксотропия' => 'tıksotropıa','авантюристік' => 'avantúrıstik','эмульгирлену' => 'emúlgırlený','вариометр' => 'varıometr','аяқартқыш' => 'aıaqartqysh','флексия' => 'fleksıa','жариялаушы' => 'jarıalaýshy','тиянақтылық' => 'tıanaqtylyq','модернист' => 'modernıs','тыссыз' => 'tyssyz','ядрошық' => 'ıadroshyq','ықтиярсыз' => 'yqtıarsyz','күржию' => 'kúrjıý','ария' => 'arıa','эллипсограф' => 'elıpsograf','жалғызаяқ' => 'jalǵyzaıaq','мүддесіз' => 'múddesiz','бальзам' => 'bálzam','қаю' => 'qaıý','артикуляция' => 'artıkýlásıa','фашист' => 'fashıs','баяғыдай' => 'baıaǵydaı','дивизия' => 'dıvızıa','қария' => 'qarıa','атантұяқ' => 'atantuıaq','тікею' => 'tikeıý','бұдырмия' => 'budyrmıa','кассация' => 'kasasıa','интервенция' => 'ıntervensıa','көпаяқты' => 'kópaıaqty','артериялық' => 'arterıalyq','петрология' => 'petrologıa','полиграфия' => 'polıgrafıa','азиялық' => 'azıalyq','самиян' => 'samıan','таяқтай' => 'taıaqtaı','сояу' => 'soıaý','құяқ' => 'quıaq','аяқжол' => 'aıaqjol','фонография' => 'fonografıa','бастан-аяқ' => 'bastan-aıaq','риян' => 'rıan','амбулатория' => 'ambýlatorıa','жаяулату' => 'jaıaýlatý','қоянбұршақ' => 'qoıanburshaq','утопиялық' => 'ýtopıalyq','даярлық' => 'daıarlyq','еммат' => 'emat','калькуляция' => 'kálkýlásıa','пункция' => 'pýnksıa','милитаризация' => 'mılıtarızasıa','аюбадам' => 'aıýbadam','аллея' => 'aleıa','аллергология' => 'alergologıa','обелиск' => 'obelısk','дерматология' => 'dermatologıa','плащ-палатка' => 'plash-palatka','теңаяқтылар' => 'teńaıaqtylar','көзбояу' => 'kózboıaý','гидрологиялық' => 'gıdrologıalyq','қиқаю' => 'qıqaıý','телестудия' => 'telestýdıa','жыртию' => 'jyrtıý','оюлану' => 'oıýlaný','микрия' => 'mıkrıa','аллегорлау' => 'alegorlaý','махист' => 'mahıs','аяқмәшине' => 'aıaqmáshıne','жариялық' => 'jarıalyq','альфа' => 'álfa','венчурлік' => 'venchýrlik','қампаю' => 'qampaıý','экссудат' => 'ekssýdat','саятшыл' => 'saıatshyl','құпияшыл' => 'qupıashyl','жаяулау' => 'jaıaýlaý','федерациялық' => 'federasıalyq','аязсымақ' => 'aıazsymaq','аядай' => 'aıadaı','аярсу' => 'aıarsý','координациялау' => 'koordınasıalaý','гравитациялық' => 'gravıtasıalyq','оккупациялық' => 'okýpasıalyq','партия' => 'partıa','энтомология' => 'entomologıa','галантерея' => 'galantereıa','божбию' => 'bojbıý','валеология' => 'valeologıa','биометрия' => 'bıometrıa','кірбию' => 'kirbıý','археология' => 'arheologıa','альюмель' => 'alúmel','тымсыраю' => 'tymsyraıý','жаңылыссыз' => 'jańylyssyz','артист' => 'artıs','дактилоскопиялық' => 'daktıloskopıalyq','эпидемиолог' => 'epıdemıolog','лексиколог' => 'leksıkolog','аяқтаушы' => 'aıaqtaýshy','сионист' => 'sıonıs','экскурсия' => 'ekskýrsıa','радиобиология' => 'radıobıologıa','агрессия' => 'agresıa','тиіссіз' => 'tıissiz','компьютер' => 'kompúter','варианттылық' => 'varıanttylyq','технократиялық' => 'tehnokratıalyq','деформациялау' => 'deformasıalaý','фотообъектив' => 'fotoobektıv','сиякөк' => 'sıakók','онтология' => 'ontologıa','биохимия' => 'bıohımıa','ладья' => 'ladıa','гидрометриялық' => 'gıdrometrıalyq','бериллийлеу' => 'berılıleý','гидробиологиялық' => 'gıdrobıologıalyq','кювет' => 'kúvet','эманация' => 'emanasıa','целлофан' => 'selofan','славян' => 'slaván','палеография' => 'paleografıa','аяқбәйге' => 'aıaqbáıge','биобиблиографиялық' => 'bıobıblıografıalyq','латифундия' => 'latıfýndıa','боян' => 'boıan','геморрой' => 'gemoroı','хронобиология' => 'hronobıologıa','анатомия' => 'anatomıa','вексель' => 'veksel','юнион' => 'ıýnıon','классик' => 'klasık','ешкімия' => 'eshkimıa','айтұяқ' => 'aıtuıaq','ағжию' => 'aǵjıý','тұп-тұщы' => 'tup-tushshy','анапест' => 'anapes','тамырбояу' => 'tamyrboıaý','компьютерлік' => 'kompúterlik','қоянқұлақ' => 'qoıanqulaq','өңею' => 'óńeıý','шалқию' => 'shalqıý','миллиметр' => 'mıllımetr','ыржию' => 'yrjıý','букинист' => 'býkınıs','бұрыннан' => 'burynnan','иерархиялық' => 'ıerarhıalyq','гомология' => 'gomologıa','элегист' => 'elegıs','вегетативті' => 'vegetatıvti','өмірбаян' => 'ómirbaıan','шаялық' => 'shaıalyq','боржию' => 'borjıý','консолидация' => 'konsolıdasıa','шараяқ' => 'sharaıaq','кежірею' => 'kejireıý','трюк' => 'trúk','анархиялық' => 'anarhıalyq','алюминат' => 'alúmınat','гектоватт' => 'gektovatt','қаяушыл' => 'qaıaýshyl','микроассамблер' => 'mıkroasambler','редакциялау' => 'redaksıalaý','алюминийлі' => 'alúmınıli','уранография' => 'ýranografıa','модификациялау' => 'modıfıkasıalaý','иррационалдық' => 'ırasıonaldyq','диссимиляциялану' => 'dısımılásıalaný','балладалық' => 'balladalyq','металлоид' => 'metaloıd','галлий' => 'galı','баян' => 'baıan','альбинизм' => 'álbınızm','хеджерлеу' => 'hejerleý','саптаяқ' => 'saptaıaq','саябырлау' => 'saıabyrlaý','трансмиссия' => 'transmısıa','материя' => 'materıa','форпост' => 'forpos','модификациялық' => 'modıfıkasıalyq','тыю' => 'tyıý','транскрипция' => 'transkrıpsıa','комиссариат' => 'komısarıat','аккордтық' => 'akordtyq','бүкшию' => 'búkshıý','типография' => 'tıpografıa','оппонент' => 'oponent','шаяндәуіт' => 'shaıandáýit','унция' => 'ýnsıa','миолог' => 'mıolog','вольтметр' => 'vóltmetr','пласт' => 'plas','ремиссия' => 'remısıa','венчур' => 'venchýr','коммуникация' => 'komýnıkasıa','терминологиялық' => 'termınologıalyq','фольклор' => 'fólklor','ықтиятсыздық' => 'yqtıatsyzdyq','гидроэкструзия' => 'gıdroekstrýzıa','ұяңдау' => 'uıańdaý','рефлексия' => 'refleksıa','екіаяқты' => 'ekiaıaqty','мәніссіз' => 'mánissiz','ашатұяқ' => 'ashatuıaq','базофилиялық' => 'bazofılıalyq','эпизоотология' => 'epızootologıa','цитология' => 'sıtologıa','дию' => 'dıý','күрекаяқты' => 'kúrekaıaqty','палеогеографиялық' => 'paleogeografıalyq','төсекаяқ' => 'tósekaıaq','пресс-конференция' => 'pres-konferensıa','қаяулық' => 'qaıaýlyq','мұқияттылық' => 'muqıattylyq','автомобильші' => 'avtomobılshi','ватман' => 'vatman','радиогидрогеология' => 'radıogıdrogeologıa','бариглоссия' => 'barıglosıa','аяқ-қаптай' => 'aıaq-qaptaı','эвфония' => 'evfonıa','қаярлық' => 'qaıarlyq','аямай' => 'aıamaı','барбию' => 'barbıý','микробиология' => 'mıkrobıologıa','инквизиция' => 'ınkvızısıa','разрядтық' => 'razrádtik','таңқию' => 'tańqıý','зымияндық' => 'zymıandyq','гамма-глобулин' => 'gamma-globýlın','миқию' => 'mıqıý','акт' => 'akt','ашаддылық' => 'ashaddylyq','құтаю' => 'qutaıý','ономатология' => 'onomatologıa','бюрократизм' => 'búrokratızm','әлхамдилла' => 'álhamdılla','коммюнике' => 'komúnıke','кокцидия' => 'koksıdıa','геологиялық' => 'geologıalyq','территориялық' => 'terıtorıalyq','плащ' => 'plash','формация' => 'formasıa','грамм-атом' => 'gramm-atom','көкпияз' => 'kókpıaz','үңірею' => 'úńireıý','тасқаяқтай' => 'tasqaıaqtaı','шоқшию' => 'shoqshıý','интеграция' => 'ıntegrasıa','элегиялық' => 'elegıalyq','тонна' => 'tonna','артерия' => 'arterıa','тыңаю' => 'tyńaıý','рубаят' => 'rýbaıat','оффшорлық' => 'ofshorlyq','жеңіліссіз' => 'jeńilissiz','состию' => 'sostıý','әуенавигация' => 'áýenavıgasıa','гипология' => 'gıpologıa','лингвист' => 'lıngvıs','мая' => 'maıa','аяғансу' => 'aıaǵansý','гамма-спектрометр' => 'gamma-spektrometr','бактериолог' => 'bakterıolog','координациялық' => 'koordınasıalyq','миллениум' => 'mıllenıým','мирассыз' => 'mırassyz','апоплексия' => 'apopleksıa','хирургия' => 'hırýrgıa','радиохимия' => 'radıohımıa','семитолог' => 'semıtolog','демографиялық' => 'demografıalyq','қияпат' => 'qıapat','фенологиялық' => 'fenologıalyq','экономия' => 'ekonomıa','ескекаяқтылар' => 'eskekaıaqtylar','агрономиялық' => 'agronomıalyq','топография' => 'topografıa','орфограммалау' => 'orfogramdaý','бүржию' => 'búrjıý','урологиялық' => 'ýrologıalyq','микробактерия' => 'mıkrobakterıa','аяласу' => 'aıalasý','ингалятор' => 'ıngalátor','рупия' => 'rýpıa','компьютерлендіру' => 'kompúterlendirý','эксплозия' => 'eksplozıa','комбинация' => 'kombınasıa','тисса' => 'tısa','таяқталу' => 'taıaqtalý','ою' => 'oıý','процесс' => 'proses','теңдессіз' => 'teńdessiz','глоттогенез' => 'glotogenez','коллоквиум' => 'kolokvıým','венерология' => 'venerologıa','тесірею' => 'tesireıý','қоянот' => 'qoıanot','баяусыну' => 'baıaýsyný','таяқсыз' => 'taıaqsyz','шаю' => 'shaıý','жапыраю' => 'japyraıý','альянс' => 'aláns','разряд' => 'razrád','акселерация' => 'akselerasıa','винил' => 'vınıl','брасс' => 'bras','некен-саяқ' => 'neken-saıaq','қалқаю' => 'qalqaıý','фотографиялау' => 'fotografıalaý','аяу' => 'aıaý','жариялату' => 'jarıalatý','шошаю' => 'shoshaıý','жария' => 'jarıa','валорлық' => 'valorlyq','биотехния' => 'bıotehnıa','ызу-қию' => 'yzý-qıý','биоценология' => 'bıosenologıa','ферробалқыту' => 'ferobalqytý','квадриллион' => 'kvadrıllıon','тырию' => 'tyrıý','ампелография' => 'ampelografıa','неопаллиум' => 'neopalıým','қиял' => 'qıal','компресс' => 'kompres','метонимия' => 'metonımıa','желмаядай' => 'jelmaıadaı','парафемия' => 'parafemıa','доссымақ' => 'dossymaq','кеңкию' => 'keńkıý','анархия' => 'anarhıa','мүдде-мұрат' => 'múdde-murat','желмая' => 'jelmaıa','биомасса' => 'bıomassa','гомологиялық' => 'gomologıalyq','арсию' => 'arsıý','кюри' => 'kúrı','әуекомпания' => 'áýekompanıa','қоянқұйрық' => 'qoıanquıryq','магнитометриялық' => 'magnıtometrıalyq','батрахология' => 'batrahologıa','аффект' => 'afekt','ояну' => 'oıaný','пролог' => 'prolog','автомобиль' => 'avtomobıl','отоларинголог' => 'otolarıngolog','бактериологиялық' => 'bakterıologıalyq','десорбция' => 'desorbsıa','кідіріссіз' => 'kidirissiz','қарғатұяқ' => 'qarǵatuıaq','вирулентті' => 'vırýlentti','глоттогениялық' => 'glotogenıalyq','ванилин' => 'vanılın','шаялану' => 'shaıalaný','шөмею' => 'shómeıý','аяқ-қапсыз' => 'aıaq-qapsyz','перфорация' => 'perforasıa','полисемиялы' => 'polısemıaly','аммиак' => 'amıak','авантюра' => 'avantúra','зияндылық' => 'zıandylyq','болбыраю' => 'bolbyraıý','парашют' => 'parashút','бояуша' => 'boıaýsha','түссіз' => 'tússiz','мияткерлік' => 'mıatkerlik','биллион' => 'bıllıon','қоспартиялық' => 'qospartıalyq','аттракцион' => 'atraksıon','тәлтию' => 'táltıý','гроссмейстер' => 'grosmeıster','жою' => 'joıý','пеленг' => 'peleń','конъюнктура' => 'konúnktýra','қақию' => 'qaqıý','контакт' => 'kontakt','саясаттандыру' => 'saıasattandyrý','тараю' => 'taraıý','аярлану' => 'aıarlaný','тьютор' => 'tútor','комиссия' => 'komısıa','аушадияр' => 'aýshadıar','қол-аяғы' => 'qol-aıaǵy','зиянкестік' => 'zıankestik','беллетрист' => 'beletrıs','антрополог' => 'antropolog','вагон-мейрамхана' => 'vagon-meıramhana','пирротин' => 'pırotın','ескекаяқ' => 'eskekaıaq','капеллалық' => 'kapelalyq','тысқаяқ' => 'tysqaıaq','пессимист' => 'pesımıs','индукциялы' => 'ındýksıaly','төбелессіз' => 'tóbelessiz','джунгли' => 'jýnglı','идеолог' => 'ıdeolog','тұяқ' => 'tuıaq','субвенция' => 'sýbvensıa','аллегория' => 'alegorıa','рояль' => 'roıál','комиссарлық' => 'komısarlyq','аңқаю' => 'ańqaıý','технология' => 'tehnologıa','модаль' => 'modál','монокристалл' => 'monokrıstal','монументалист' => 'monýmentalıs','турист' => 'týrıs','муссурана' => 'mýsýrana','аялдама-бекініс' => 'aıaldama-bekinis','эллинизм' => 'elınızm','биссектриса' => 'bısektrısa','генералиссимустық' => 'generalısımýstyq','филлит' => 'fılıt','қуаяқ' => 'qýaıaq','поэзиялық' => 'poezıalyq','полифония' => 'polıfonıa','балпаю' => 'balpaıý','алтаяқты' => 'altaıaqty','аяусыз' => 'aıaýsyz','варианттық' => 'varıanttyq','тиянақтау' => 'tıanaqtaý','яхта' => 'ıahta','литофагия' => 'lıtofagıa','аяқтану' => 'aıaqtaný','ультиматум' => 'últımatým','жауқияқ' => 'jaýqıaq','милитаризациялау' => 'mılıtarızasıalaý','гидролог' => 'gıdrolog','миллионер' => 'mıllıoner','теориялық' => 'teorıalyq','тест' => 'test','агрохимия' => 'agrohımıa','культ' => 'kúlt','вольфрамит' => 'vólframıt','боямалы' => 'boıamaly','финикия' => 'fınıkıa','қассақ' => 'qassaq','филателист' => 'fılatelıs','аксельбант' => 'akselbant','натуралист' => 'natýralıs','авиация' => 'avıasıa','кристалл' => 'krıstal','режиссерлік' => 'rejıserlik','мүддешіл' => 'múddeshil','жуып-шаю' => 'jýyp-shaıý','логография' => 'logografıa','жампию' => 'jampıý','микроскопия' => 'mıkroskopıa','король' => 'koról','аллеясыз' => 'aleıasyz','ядкар' => 'ıadkar','категориялы' => 'kategorıaly','гаплология' => 'gaplologıa','инерциясыз' => 'ınersıasyz','парономазия' => 'paronomazıa','құз-қия' => 'quz-qıa','түссіздену' => 'tússizdený','дебют' => 'debút','ояңдату' => 'oıańdatý','габбро-диабаз' => 'gabro-dıabaz','оппоненттік' => 'oponenttik','нейрохирургия' => 'neırohırýrgıa','амальгама' => 'amálgama','ықтияттылық' => 'yqtıattylyq','қоянқұлақшам' => 'qoıanqulaqsham','пассионарлық' => 'pasıonarlyq','мусс' => 'mýs','аяқтау' => 'aıaqtaý','оппозициялық' => 'opozısıalyq','зоология' => 'zoologıa','туффит' => 'týfıt','апперцепция' => 'apersepsıa','нитрификациялаушы' => 'nıtrıfıkasıalaýshy','геометриялық' => 'geometrıalyq','жаяу-жалпы' => 'jaıaý-jalpy','синолог' => 'sınolog','пародия' => 'parodıa','монопсония' => 'monopsonıa','алюмсиликаттар' => 'alúmsılıkattar','шая' => 'shaıa','асатаяқ' => 'asataıaq','мономания' => 'monomanıa','дәлдию' => 'dáldıý','антропогеография' => 'antropogeografıa','филармония' => 'fılarmonıa','ядролық' => 'ıadrolyq','империалист' => 'ımperıalıs','цессия' => 'sesıa','ватт' => 'vatt','барилалия' => 'barılalıa','томсыраю' => 'tomsyraıý','ұйқассыз' => 'uıqassyz','веб-торап' => 'veb-torap','витасфера' => 'vıtasfera','петрография' => 'petrografıa','аккредитив' => 'akredıtıv','ояңдау' => 'oıańdaý','урядник' => 'ýrádnık','маялану' => 'maıalaný','дифференциация' => 'dıferensıasıa','диалектолог' => 'dıalektolog','абылхаят' => 'abylhaıat','филологиялық' => 'fılologıalyq','шағырбояу' => 'shaǵyrboıaý','ащылы' => 'ashshyly','ояң' => 'oıań','көмпию' => 'kómpıý','алкоголь' => 'alkogól','жағдаяттық' => 'jaǵdaıattyq','өмірзая' => 'ómirzaıa','гастроль' => 'gastról','таңыраю' => 'tańyraıý','разрядталу' => 'razrádtelý','садист' => 'sadıs','гаплосемия' => 'gaplosemıa','ой-қиял' => 'oı-qıal','газбаллонды' => 'gazbalondy','реверсия' => 'reversıa','акватория' => 'akvatorıa','типографиялық' => 'tıpografıalyq','нигилист' => 'nıgılıs','антиципация' => 'antısıpasıa','саялы' => 'saıaly','бальнеология' => 'bálneologıa','аллотропия' => 'alotropıa','ләббай' => 'lábbaı','браунинг' => 'braýnıń','экскурсиялық' => 'ekskýrsıalyq','гамма-қондырғы' => 'gamma-qondyrǵy','ояңдық' => 'oıańdyq','аппаратура' => 'aparatýra','аккредиттеу' => 'akredıtteý','эволюционист' => 'evolúsıonıs','диссертант' => 'dısertant','тарбаю' => 'tarbaıý','зая' => 'zaıa','геотехнология' => 'geotehnologıa','ықтият' => 'yqtıat','бювет' => 'búvet','грамматика' => 'gramatıka','альбом' => 'álbom','әбессіну' => 'ábessiný','терроризм' => 'terorızm','ансамбль' => 'ansámbl','аусию' => 'aýsıý','ыңқию' => 'yńqıý','жалқаяқтану' => 'jalqaıaqtaný','қию' => 'qıý','эскадрилья' => 'eskadrılıa','ұялшақ' => 'uıalshaq','пияла' => 'pıala','пұштыраю' => 'pushtyraıý','палеопсихология' => 'paleopsıhologıa','барраж' => 'baraj','әскери-саяси' => 'áskerı-saıası','цинкография' => 'sınkografıa','құнтию' => 'quntıý','алдияр' => 'aldıar','миялау' => 'mıalaý','контральто' => 'kontrálto','аяугершілік' => 'aıaýgershilik','биялайдай' => 'bıalaıdaı','қасқаю' => 'qasqaıý','бақыраю' => 'baqyraıý','баяндау' => 'baıandaý','тиянақтату' => 'tıanaqtatý','үдірею' => 'údireıý','монофтонг' => 'monoftoń','еуразияшылдық' => 'eýrazıashyldyq','ассимиляциялау' => 'asımılásıalaý','фельетон' => 'feleton','саңқию' => 'sańqıý','аттылы-жаяулы' => 'attyly-jaıaýly','хайринг' => 'haırıń','сақию' => 'saqıý','масс-медиа' => 'mass-medıa','көкию' => 'kókıý','криминолог' => 'krımınolog','зиян' => 'zıan','ұя' => 'uıa','сентименталист' => 'sentımentalıs','эксплантация' => 'eksplantasıa','биосаясат' => 'bıosaıasat','конкреция' => 'konkresıa','ванадийлі' => 'vanadıli','эпиляция' => 'epılásıa','фестиваль' => 'festıvál','мияу-мияу' => 'mıaý-mıaý','ащыот' => 'ashshyot','бассауға' => 'bassaýǵa','теократиялық' => 'teokratıalyq','альтернатива' => 'álternatıv','тригонометриялық' => 'trıgonometrıalyq','көкаяз' => 'kókaıaz','аяқталу' => 'aıaqtalý','формациялық' => 'formasıalyq','алюминийлеу' => 'alúmınıleý','коммунист' => 'komýnıs','жариялылық' => 'jarıalylyq','трансплантация' => 'transplantasıa','қырықаяқ' => 'qyryqaıaq','саясаттану' => 'saıasattaný','пульт' => 'púlt','логографиялық' => 'logografıalyq','ихтиолог' => 'ıhtıolog','апробациялау' => 'aprobasıalaý','сомпаю' => 'sompaıý','помещик' => 'pomeshık','геоморфолог' => 'geomorfolog','бұртию' => 'burtıý','шалжию' => 'shaljıý','аюқұлақ' => 'aıýqulaq','кірпияз' => 'kirpıaz','іркіліссіз' => 'irkilissiz','миялы' => 'mıaly','гипотрофия' => 'gıpotrofıa','траекториялық' => 'traektorıalyq','қияңқылық' => 'qıańqylyq','фонология' => 'fonologıa','боямашы' => 'boıamashy','пиктограмма' => 'pıktogram','альпинарий' => 'álpınarı','омсыраю' => 'omsyraıý','биостратиграфиялық' => 'bıostratıgrafıalyq','геодезияшы' => 'geodezıashy','ұятсыз' => 'uıatsyz','философиялық' => 'fılosofıalyq','генеалогия' => 'genealogıa','дамолла' => 'damola','мақсат-мүдде' => 'maqsat-múdde','гипотония' => 'gıpotonıa','саясат' => 'saıasat','партияшылдық' => 'partıashyldyq','аютабан' => 'aıýtaban','бульдог' => 'búldog','тызғаяқтау' => 'tyzǵaıaqtaý','такт' => 'takt','кірпияздық' => 'kirpıazdyq','агрессиялық' => 'agresıalyq','неофазия' => 'neofazıa','мүфтият' => 'múftıat','гидроэкология' => 'gıdroekologıa','шаянмойнақ' => 'shaıanmoınaq','минерагения' => 'mıneragenıa','жаһаннам' => 'jahannam','электртермиялық' => 'elektrtermıalyq','гипотимия' => 'gıpotımıa','экономист' => 'ekonomıs','гальманин' => 'gálmanın','оптимист' => 'optımıs','амнезия' => 'amnezıa','гидроавиация' => 'gıdroavıasıa','одыраю' => 'odyraıý','оя' => 'oıa','патологиялық' => 'patologıalyq','анестезия' => 'anestezıa','баябан' => 'baıaban','өңірею' => 'óńireıý','мумиядай' => 'mýmıadaı','эккаутинг' => 'ekaýtıń','қыдию' => 'qydıý','магнолия' => 'magnolıa','астробиология' => 'astrobıologıa','аярлықтай' => 'aıarlyqtaı','астапыралла' => 'astapyralla','киносаяхат' => 'kınosaıahat','сия' => 'sıa','акцентология' => 'aksentologıa','классицизм' => 'klasısızm','рентгенотерапия' => 'rentgenoterapıa','лоция' => 'losıa','тұқию' => 'tuqıý','құлқуалла' => 'qulqýalla','ұлғая-ұлғая' => 'ulǵaıa-ulǵaıa','тіссіздік' => 'tissizdik','қаздию' => 'qazdıý','популист' => 'popýlıs','аяулау' => 'aıaýlaý','биогеология' => 'bıogeologıa','елессіз' => 'elessiz','жарияланым' => 'jarıalanym','диалектология' => 'dıalektologıa','вариациялану' => 'varıasıalaný','астрономиялық' => 'astronomıalyq','шаянтәрізділер' => 'shaıantárizdiler','әуетаяқ' => 'áýetaıaq','борпию' => 'borpıý','аяқ-табақты' => 'aıaq-tabaqty','палеомагнитология' => 'paleomagnıtologıa','инжиниринг' => 'ınjınırıń','даяшылық' => 'daıashylyq','қартаю' => 'qartaıý','барристер' => 'barıster','тартыссыз' => 'tartyssyz','бактериялы' => 'bakterıaly','мультипликациялық' => 'múltıplıkasıalyq','грамм' => 'gram','гидрометеорология' => 'gıdrometeorologıa','шанжию' => 'shanjıý','болыссымақ' => 'bolyssymaq','навигация' => 'navıgasıa','милитарист' => 'mılıtarıs','экологияландыру' => 'ekologıalandyrý','цитоэкология' => 'sıtoekologıa','инверсиялық' => 'ınversıalyq','панисламист' => 'panıslamıs','аязшал' => 'aıazshal','түссіздендіру' => 'tússizdendirý','дипломатиялық' => 'dıplomatıalyq','ырыссыз' => 'yryssyz','аяздай' => 'aıazdaı','бассейн' => 'baseın','дүмпию' => 'dúmpıý','эмулятор' => 'emýlátor','коммунар' => 'komýnar','вегетация' => 'vegetasıa','қапияда' => 'qapıada','каталог' => 'katalog','өлеңқияқ' => 'óleńqıaq','аюоты' => 'aıýoty','гипоксия' => 'gıpoksıa','альтруизм' => 'áltrýızm','вокализм' => 'vokalızm','сықсыраю' => 'syqsyraıý','вокалды' => 'vokaldy','тақыраю' => 'taqyraıý','риялы' => 'rıaly','инерциялық' => 'ınersıalyq','мотокросс' => 'motokros','патергазия' => 'patergazıa','джаз' => 'jaz','прогресс' => 'progres','идеялы' => 'ıdeıaly','автосаяхат' => 'avtosaıahat','жаялықтай' => 'jaıalyqtaı','беккерель' => 'bekerel','тапқан-таянғаны' => 'tapqan-taıanǵany','жыланқияқ' => 'jylanqıaq','психолог' => 'psıholog','гидробиология' => 'gıdrobıologıa','фрустрация' => 'frýstrasıa','бумеранг' => 'býmerań','қаяудай' => 'qaıaýdaı','тұрнияз' => 'turnıaz','нюанс' => 'núans','поэзия' => 'poezıa','комплексонометрия' => 'kompleksonometrıa','пассионар' => 'pasıonar','аюдай' => 'aıýdaı','метеорологиялық' => 'meteorologıalyq','асимметриялық' => 'asımetrıalyq','бассауғалау' => 'bassaýǵalaý','сұстию' => 'sustıý','вето' => 'veto','шақыраю' => 'shaqyraıý','ортопедия' => 'ortopedıa','ессіздік' => 'essizdik','тыраю' => 'tyraıý','қиягездік' => 'qıagezdik','эмиссия' => 'emısıa','шертию' => 'shertıý','шоштию' => 'shoshtıý','гомеопатия' => 'gomeopatıa','көстию' => 'kóstıý','борбию' => 'borbıý','қаратаяқ' => 'qarataıaq','демобилизациялық' => 'demobılızasıalyq','тоңқию' => 'tońqıý','ақмия' => 'aqmıa','барракуда' => 'barakýda','дебютант' => 'debútant','габброидтену' => 'gabroıdtený','аяқжақсы' => 'aıaqjaqsy','қаңқаю' => 'qańqaıý','вестерн' => 'vestern','ықылассыздық' => 'yqylassyzdyq','вокалдық' => 'vokaldyq','вектор' => 'vektor','микропсия' => 'mıkropsıa','батиметриялық' => 'batımetrıalyq','трагедия' => 'tragedıa','аметист' => 'ametıs','телеграфия' => 'telegrafıa','ромб' => 'romb','эмоциялылық' => 'emosıalylyq','жалқаяқтай' => 'jalqaıaqtaı','ультра' => 'últra','қаймию' => 'qaımıý','палинтомия' => 'palıntomıa','монист' => 'monıs','вермахт' => 'vermaht','жанқияр' => 'janqıar','руханияттық' => 'rýhanıattyq','вегетерианшылық' => 'vegeterıanshylyq','борсию' => 'borsıý','флюорография' => 'flúorografıa','дария' => 'darıa','биотехнология' => 'bıotehnologıa','пропорциялау' => 'proporsıalaý','алыс-жұлыссыз' => 'alys-julyssyz','морфология' => 'morfologıa','пульс' => 'púls','флюороз' => 'flúoroz','голографиялық' => 'golografıalyq','зиянды' => 'zıandy','гинеколог' => 'gınekolog','дәсмия' => 'dásmıa','аяз-боран' => 'aıaz-boran','альвекоккоз' => 'alvekokoz','күдірею' => 'kúdireıý','демаркациялау' => 'demarkasıalaý','термохимия' => 'termohımıa','құмқоян' => 'qumqoıan','алюминий' => 'alúmını','рияландыру' => 'rıalandyrý','камер-юнкер' => 'kamer-únker','декорациялық' => 'dekorasıalyq','қақаю' => 'qaqaıý','чартист' => 'chartıs','конфессия' => 'konfesıa','коммутация' => 'komýtasıa','бейсаясаттық' => 'beısaıasattyq','имманенттік' => 'ımanentik','диаграмма' => 'dıagram','тотияйындай' => 'totıaıyndaı','пирометрия' => 'pırometrıa','палеозоология' => 'paleozoologıa','миядай' => 'mıadaı','партиясыздық' => 'partıasyzdyq','жаһаннамдық' => 'jahannamdyq','безаяқ' => 'bezaıaq','материялық' => 'materıalyq','бакалея' => 'bakaleıa','аяқкиім' => 'aıaqkıim','трест' => 'tres','саяқсу' => 'saıaqsý','қоңқию' => 'qońqıý','кетию' => 'ketıý','гидрохимия' => 'gıdrohımıa','полиция' => 'polısıa','оюлату' => 'oıýlatý','сұрқия' => 'surqıa','қидию' => 'qıdıý','аямпаз' => 'aıampaz','бояуүккіш' => 'boıaýúkkish','технолог' => 'tehnolog','шілтию' => 'shiltıý','фонографиялық' => 'fonografıalyq','брифинг' => 'brıfıń','парафония' => 'parafonıa','қитию' => 'qıtıý','туыссыздық' => 'týyssyzdyq','лицензия' => 'lısenzıa','бояң' => 'boıań','жаяу' => 'jaıaý','аяңдату' => 'aıańdatý','аяқбаулы' => 'aıaqbaýly','террамицин' => 'teramısın','кросс' => 'kros','генерал-адъютант' => 'general-adútant','ньюсмейкер' => 'núsmeıker','палеогеоморфологиялық' => 'paleogeomorfologıalyq','обструкционист' => 'obstrýksıonıs','волластонит' => 'volastonıt','уәллаһи' => 'ýállahı','сиясорғыш' => 'sıasorǵysh','иммунитет' => 'ımýnıtet','баяғыдағы' => 'baıaǵydaǵy','террарий' => 'terarı','автоинспекция' => 'avtoınspeksıa','тікірею' => 'tikireıý','дардию' => 'dardıý','ашадды' => 'ashaddy','апельсин' => 'apelsın','аясыз' => 'aıasyz','тәуірмия' => 'táýirmıa','ферментация' => 'fermentasıa','төссіз' => 'tóssiz','фаготерапия' => 'fagoterapıa','биогеоценологиялық' => 'bıogeosenologıalyq','асканиялық' => 'askanıalyq','радиоастрономия' => 'radıoastronomıa','ояту' => 'oıatý','қарааяқ' => 'qaraaıaq','габбролық' => 'gabrolyq','комменсализм' => 'komensalızm','апперкот' => 'aperkot','доссыз' => 'dossyz','валокордин' => 'valokordın','фразеологиялық' => 'frazeologıalyq','бальзамин' => 'bálzamın','монополист' => 'monopolıs','таяздату' => 'taıazdatý','девиация' => 'devıasıa','аппроксимация' => 'aproksımasıa','тоят' => 'toıat','таяздану' => 'taıazdaný','зияратшы' => 'zıaratshy','радиограмма' => 'radıogram','ырсию' => 'yrsıý','фармакология' => 'farmakologıa','сербию' => 'serbıý','цессионарий' => 'sesıonarı','пропорция' => 'proporsıa','прогрессия' => 'progresıa','сапсию' => 'sapsıý','риясыздық' => 'rıasyzdyq','дирекция' => 'dıreksıa','ащылату' => 'ashshylatý','кальцит' => 'kálsıt','өріссіздік' => 'órissizdik','дөңкию' => 'dóńkıý','венедтер' => 'venedter','эмболия' => 'embolıa','коллекция' => 'koleksıa','шартию' => 'shartıý','репарациялық' => 'reparasıalyq','аяқ-табақсыз' => 'aıaq-tabaqsyz','элизия' => 'elızıa','геолог' => 'geolog','андеррайтер' => 'anderaıter','геология' => 'geologıa','пиязгүл' => 'pıazgúl','лицензиялану' => 'lısenzıalaný','микрохирургия' => 'mıkrohırýrgıa','даярлықсыз' => 'daıarlyqsyz','классификатор' => 'klasıfıkator','аялату' => 'aıalatý','милливатт' => 'mıllıvat','күюлі' => 'kúıýli','сыптию' => 'syptıý','аяқтаусыз' => 'aıaqtaýsyz','глютин' => 'glútın','океанолог' => 'okeanolog','резолюция' => 'rezolúsıa','ясин' => 'ıasın','миллиардтай' => 'mıllıardtaı','экопсихология' => 'ekopsıhologıa','редукция' => 'redýksıa','алхимияшылдар' => 'alhımıashyldar','магнитометрия' => 'magnıtometrıa','раббы' => 'rabby','спектакль' => 'spektákl','әмиян' => 'ámıan','саяттық' => 'saıattyq','қаратұяқтану' => 'qaratuıaqtaný','ықылассыздау' => 'yqylassyzdaý','бельэтаж' => 'beletaj','тоңыраю' => 'tońyraıý','аңқаюлы' => 'ańqaıýly','талтаю' => 'taltaıý','антерринум' => 'anterıným','фобия' => 'fobıa','диахрония' => 'dıahronıa','жамбассипар' => 'jambassıpar','хронолог' => 'hronolog','модуляциялау' => 'modýlásıalaý','шаянот' => 'shaıanot','қысылтаяң' => 'qysyltaıań','жорғатаяқ' => 'jorǵataıaq','аяныштау' => 'aıanyshtaý','элегия' => 'elegıa','аянсыз' => 'aıansyz','агроклиматология' => 'agroklımatologıa','гиббон' => 'gıbon','қиямет' => 'qıamet','идеологиялық' => 'ıdeologıalyq','венеролог' => 'venerolog','пьеса' => 'pesa','мият' => 'mıat','баяғыдан' => 'baıaǵydan','перпендикуляр' => 'perpendıkýlár','гратификация' => 'gratıfıkasıa','генералиссимус' => 'generalısımýs','вирустасығыш' => 'vırýstasyǵysh','ықтиярхат' => 'yqtıarhat','уробактериялар' => 'ýrobakterıalar','сораю' => 'soraıý','югославтар' => 'ıýgoslavtar','инновация' => 'ınovasıa','абляция' => 'ablásıa','боссөзділік' => 'bossózdilik','глоттогения' => 'glotogenıa','магия' => 'magıa','бажыраю' => 'bajyraıý','армиялық' => 'armıalyq','шолжию' => 'sholjıý','миятамыр' => 'mıatamyr','глоссарий' => 'glosarı','әкірею' => 'ákireıý','элювий' => 'elúvı','аяққұр' => 'aıaqqur','ұялшақтық' => 'uıalshaqtyq','галлица' => 'galısa','тригонометрия' => 'trıgonometrıa','қоянқарта' => 'qoıanqarta','бояудай' => 'boıaýdaı','радиожурналист' => 'radıojýrnalıs','позициялық' => 'pozısıalyq','биобиблиография' => 'bıobıblıografıa','қаят' => 'qaıat','концессия' => 'konsesıa','тасыраю' => 'tasyraıý','пароль' => 'paról','инфантерия' => 'ınfanterıa','яппи' => 'ıappı','аяққап' => 'aıaqqap','долларлы' => 'dollarly','гносеология' => 'gnoseologıa','дубль' => 'dúbl','ұяң' => 'uıań','саятшылық' => 'saıatshylyq','саяздау' => 'saıazdaý','аяқ' => 'aıaq','зият' => 'zıat','артиллериялық' => 'artılerıalyq','арман-қиял' => 'arman-qıal','артикуляциялық' => 'artıkýlásıalyq','бояқ' => 'boıaq','монархияшыл' => 'monarhıashyl','аскания' => 'askanıa','вальс' => 'váls','ванадаттар' => 'vanadattar','құя' => 'quıa','исламият' => 'ıslamıat','баяғыша' => 'baıaǵysha','ұябасар' => 'uıabasar','ямб' => 'ıamb','қылмию' => 'qylmıý','формуляр' => 'formýlár','алдиярлау' => 'aldıarlaý','айғырқияқ' => 'aıǵyrqıaq','аяқ-табақ' => 'aıaq-tabaq','фитопатология' => 'fıtopatologıa','шатқаяқ' => 'shatqaıaq','баяулау' => 'baıaýlaý','фация' => 'fasıa','новелла' => 'novela','эмбриолог' => 'embrıolog','теология' => 'teologıa','биохимиялық' => 'bıohımıalyq','жеміссерік' => 'jemisserik','корректуралық' => 'korektýralyq','ессіздену' => 'essizdený','тобанаяқтану' => 'tobanaıaqtaný','миелобласт' => 'mıeloblas','қазан-аяқ' => 'qazan-aıaq','бильярдшы' => 'bılárdshy','естиярлану' => 'estıarlaný','славяншылдық' => 'slavánshildik','қалбию' => 'qalbıý','аюқурай' => 'aıýqýraı','ащыласу' => 'ashshylasý','демагогия' => 'demagogıa','инверсия' => 'ınversıa','апелляция' => 'apelásıa','психопатия' => 'psıhopatıa','ию-қию' => 'ıý-qıý','қоя' => 'qoıa','бухгалтерия' => 'býhgalterıa','публицист' => 'pýblısıs','телефонограмма' => 'telefonogram','вестибюль' => 'vestıbúl','артиллерия' => 'artılerıa','аяққы' => 'aıaqqy','қоянжырық' => 'qoıanjyryq','миллиардшы' => 'mıllıardshy','баяғыда' => 'baıaǵyda','яки' => 'ıakı','матч' => 'mach','зиянсыз' => 'zıansyz','экосаяси' => 'ekosaıası','шаянша' => 'shaıansha','тракт' => 'trakt','параллельдік' => 'paraleldik','ортаазиялық' => 'ortaazıalyq','таяз' => 'taıaz','зияндау' => 'zıandaý','есептаяқ' => 'eseptaıaq','гистология' => 'gıstologıa','велосипед' => 'velosıped','сою' => 'soıý','тренинг' => 'trenıń','марксист' => 'marksıs','картодиаграмма' => 'kartodıagram','омофония' => 'omofonıa','тайпию' => 'taıpıý','вафлипісіргіш' => 'vaflıpisirgish','аберрация' => 'aberasıa','бүгжию' => 'búgjıý','зораю' => 'zoraıý','скетч' => 'skech','инфузория' => 'ınfýzorıa','руль' => 'rúl','монография' => 'monografıa','патруль' => 'patrúl','рефракция' => 'refraksıa','ляпис' => 'lápıs','діңкию' => 'dińkıý','ретроспекциялы' => 'retrospeksıaly','сүмпию' => 'súmpıý','гетерограмма' => 'geterogram','тәутию' => 'táýtıý','мияу' => 'mıaý','нейроанатомия' => 'neıroanatomıa','топсаяхат' => 'topsaıahat','қиятас' => 'qıatas','реформист' => 'reformıs','морзист' => 'morzıs','құрдассыну' => 'qurdassyný','боямалау' => 'boıamalaý','альпинист' => 'álpınıs','коммерциялық' => 'komersıalyq','миллиметрдей' => 'mıllımetrdeı','атпақияр' => 'atpaqıar','балл' => 'bal','аккумуляторшы' => 'akýmýlátorshy','суспензия' => 'sýspenzıa','аяусыздық' => 'aıaýsyzdyq','саябан' => 'saıaban','аянкестік' => 'aıankestik','холдинг' => 'holdıń','иллюминация' => 'ılúmınasıa','авантюрист' => 'avantúrıs','экструзиялық' => 'ekstrýzıalyq','ежірею' => 'ejireıý','аяқартар' => 'aıaqartar','дермиян' => 'dermıan','ұйқылы-ояу' => 'uıqyly-oıaý','жантаю' => 'jantaıý','таю' => 'taıý','конспект' => 'konspekt','аглютинация' => 'aglútınatsıa','таяну' => 'taıaný','шоқию' => 'shoqıý','гамма' => 'gamma','миллиграмдай' => 'mıllıgramdaı','антиномия' => 'antınomıa','аяш' => 'aıash','литургия' => 'lıtýrgıa','тұқшию' => 'tuqshıý','рационалист' => 'rasıonalıs','экспедициялық' => 'ekspedısıalyq','микробиолог' => 'mıkrobıolog','тұщыландыру' => 'tushshylandyrý','аялдату' => 'aıaldatý','генеалогиялық' => 'genealogıalyq','теннис' => 'tenıs','терракота' => 'terakota','дубляж' => 'dýbláj','зияпат' => 'zıapat','параллель' => 'paralel','локация' => 'lokasıa','функциялық' => 'fýnksıalyq','объект' => 'obekt','макроэволюция' => 'makroevolúsıa','массагет' => 'masaget','шарқая' => 'sharqaıa','фракция' => 'fraksıa','мультимиллионерлік' => 'múltımıllıonerlik','ономасиология' => 'onomasıologıa','автосаяхатшы' => 'avtosaıahatshy','баррикада' => 'barıkada','бортию' => 'bortıý','моногамиялық' => 'monogamıalyq','үлкею' => 'úlkeıý','алло' => 'alo','троллейбус' => 'troleıbýs','фитогеография' => 'fıtogeografıa','инновациялық' => 'ınovasıalyq','апробация' => 'aprobasıa','аккумулятор' => 'akýmýlátor','невропатолог' => 'nevropatolog','демпинг' => 'dempıń','ферроқорытпа' => 'feroqorytpa','криминалист' => 'krımınalıs','бюрократиялық' => 'búrokratıalyq','фитопатолог' => 'fıtopatolog','режиссер' => 'rejıser','аяғыш' => 'aıaǵysh','конфабуляция' => 'konfabýlásıa','физиология' => 'fızıologıa','сұрқиялық' => 'surqıalyq','рияқорлық' => 'rıaqorlyq','агрессор' => 'agresor','саяткер' => 'saıatker','символист' => 'sımvolıs','эквайринг' => 'ekvaırıń','фантазия' => 'fantazıa','мүдделес' => 'múddeles','брошюра' => 'broshúra','ұягүл' => 'uıagúl','аналогиялық' => 'analogıalyq','диссимиляция' => 'dısımılásıa','гуманист' => 'gýmanıs','солпию' => 'solpıý','эклампсия' => 'eklampsıa','монограма' => 'monogram','мифология' => 'mıfologıa','буржуазия' => 'býrjýazıa','толассыз' => 'tolassyz','біп-биязы' => 'bip-bıazy','бая' => 'baıa','шедірею' => 'shedireıý','құяң' => 'quıań','окказионал' => 'okazıonal','кеңею' => 'keńeıý','аккредитация' => 'akredıtasıa','итаяқ' => 'ıtaıaq','батареялы' => 'batareıaly','аржию' => 'arjıý','аппарель' => 'aparel','демонополизация' => 'demonopolızasıa','құпияласу' => 'qupıalasý','параллелизм' => 'paralelızm','деструкция' => 'destrýksıa','антракт' => 'antrakt','қарабаялыш' => 'qarabaıalysh','тортию' => 'tortıý','қиямет-қайым' => 'qıamet-qaıym','флотилия' => 'flotılıa','варикоз' => 'varıkoz','меңірею' => 'meńireıý','валидол' => 'valıdol','қаннен-қаперсіз' => 'qannen-qapersiz','сидию' => 'sıdıý','тақиядай' => 'taqıadaı','винчестер' => 'vınchester','оффшор' => 'ofshor','кейіссіз' => 'keıissiz','шлямбур' => 'shlámbýr','шиқияқ' => 'shıqıaq','геоэкологиялық' => 'geoekologıalyq','сиясауыт' => 'sıasaýyt','беджа' => 'bedja','таяқтату' => 'taıaqtatý','жалпаю' => 'jalpaıý','теория' => 'teorıa','томарбояу' => 'tomarboıaý','фонетист' => 'fonetıs','деривациялық' => 'derıvasıalyq','етею' => 'eteıý','индукциялану' => 'ındýksıalaný','мотороллер' => 'motoroler','көпаяқтылар' => 'kópaıaqtylar','неврология' => 'nevrologıa','қоянтәрізділер' => 'qoıantárizdiler','баржию' => 'barjıý','даярлану' => 'daıarlaný','қиқию' => 'qıqıý','коллектор' => 'kolektor','монографиялық' => 'monografıalyq','тояттық' => 'toıattyq','факторинг' => 'faktorıń','эвритермия' => 'evrıtermıa','экосаясаттану' => 'ekosaıasattaný','фотоаппарат' => 'fotoaparat','морфометрия' => 'morfometrıa','баптист' => 'baptıs','ассистент' => 'asıstent','ессіз' => 'essiz','гамма-функция' => 'gamma-fýnksıa','ұялас' => 'uıalas','патофизиология' => 'patofızıologıa','аттракция' => 'atraksıa','флюорограф' => 'flúorograf','юниор' => 'ıýnıor','қаңыраю' => 'qańyraıý','оппортунизм' => 'oportýnızm','мультимиллионер' => 'múltımıllıoner','картинг' => 'kartıń','қайқию' => 'qaıqıý','еуразиялық' => 'eýrazıalyq','баяндауыш' => 'baıandaýysh','шүңірею' => 'shúńireıý','ояздау' => 'oıazdaý','әлеуметтік-саяси' => 'áleýmettik-saıası','тілқияқ' => 'tilqıaq','вербалды' => 'verbaldy','вице-губернатор' => 'vıse-gýbernator','экономгеография' => 'ekonomgeografıa','аязды' => 'aıazdy','таяу' => 'taıaý','айыртұяқ' => 'aıyrtuıaq','қия-жар' => 'qıa-jar','кіртию' => 'kirtıý','құнжию' => 'qunjıý','альпинизм' => 'álpınızm','голограмма' => 'gologramm','аспект' => 'aspekt','нарцисс' => 'narsıs','зымияндану' => 'zymıandaný','рефлексология' => 'refleksologıa','альтрон' => 'áltron','аппликата' => 'aplıkata','лемминг' => 'lemmıń','ищай-ай' => 'ıshshaı-aı','лицензиялық' => 'lısenzıalyq','автотурист' => 'avtotýrıs','миллиграмдау' => 'mıllıgramdaý','үкіаяқ' => 'úkiaıaq','туыссыз' => 'týyssyz','корректура' => 'korektýra','редакция' => 'redaksıa','вебер' => 'veber','эпиграмма' => 'epıgram','қылтию' => 'qyltıý','көл-дария' => 'kól-darıa','фильм' => 'fılm','таяқты' => 'taıaqty','поляк' => 'polák','тиянақсыздық' => 'tıanaqsyzdyq','автономиялы' => 'avtonomıaly','ақтаяқ' => 'aqtaıaq','валеологиялық' => 'valeologıalyq','боямасыз' => 'boıamasyz','демаркациялық' => 'demarkasıalyq','ащытамыр' => 'ashshytamyr','антенналы' => 'antenaly','типология' => 'tıpologıa','қисаю' => 'qısaıý','экспромитация' => 'ekspromıtasıa','ықтияр' => 'yqtıar','баялышты' => 'baıalyshty','ювеналдық' => 'ıývenaldyq','әлеуметтік-психологиялық' => 'áleýmettik-psıhologıalyq','патиссон' => 'patıson','аязсыз' => 'aıazsyz','коннотация' => 'konotasıa','белудж' => 'belýj','космогония' => 'kosmogonıa','идиллия' => 'ıdılıa','егес-қияс' => 'eges-qıas','ампутация' => 'ampýtasıa','консьерж' => 'konserj','тиянақты' => 'tıanaqty','бүртию' => 'búrtıý','гаплобактериялар' => 'gaplobakterıalar','сейсмограмма' => 'seısmogram','тосыннан-тосын' => 'tosynnan-tosyn','ауремия' => 'aýremıa','аяқкиімсіз' => 'aıaqkıimsiz','химияландыру' => 'hımıalandyrý','кобальт' => 'kobált','ашатұяқтылар' => 'ashatuıaqtylar','аргиллит' => 'argılıt','антипартиялық' => 'antıpartıalyq','авиамодельші' => 'avıamodelshi','метеоролог' => 'meteorolog','реалист' => 'realıs','аккордеон' => 'akordeon','менеджер' => 'menedjer','вандал' => 'vandal','осциллограмма' => 'osılogram','құпиясыздау' => 'qupıasyzdaý','электрхимиялық' => 'elektrhımıalyq','тәмпию' => 'támpıý','шүртию' => 'shúrtıý','қалтию' => 'qaltıý','қылаяқ' => 'qylaıaq','бояушытыршық' => 'boıaýshytyrshyq','фракцияшылдық' => 'fraksıashyldyq','лютня' => 'lútnıa','литография' => 'lıtografıa','калориялық' => 'kalorıalyq','гипогликемия' => 'gıpoglıkemıa','шөпжияр' => 'shópjıar','жедді' => 'jeddi','аялы' => 'aıaly','тоңқаю' => 'tońqaıý','резиденция' => 'rezıdensıa','жариясыз' => 'jarıasyz','оясыз' => 'oıasyz','орфоэпиялық' => 'orfoepıalyq','пиктография' => 'pıktografıa','биотехнологиялық' => 'bıotehnologıalyq','рентгенолог' => 'rentgenolog','энциклопедия' => 'ensıklopedıa','баяулық' => 'baıaýlyq','тақияшаң' => 'taqıashań','болпию' => 'bolpıý','реваншист' => 'revanshıs','саят' => 'saıat','шлюп' => 'shlúp','аксессуар' => 'aksesýar','сыбыссыз' => 'sybyssyz','вице-президент' => 'vıse-prezıdent','мыжыраю' => 'myjyraıý','сияқты' => 'sıaqty','қаятты' => 'qaıatty','ащы' => 'ashshy','гистолог' => 'gıstolog','лоторея' => 'lotoreıa','лицензиясыз' => 'lısenzıasyz','бақтияр' => 'baqtıar','интернационалист' => 'ınternasıonalıs','бірразрядты' => 'birrazrádti','байшыл-буржуазияшыл' => 'baıshyl-býrjýazıashyl','валторна' => 'valtorna','шұқшию' => 'shuqshıý','кинорежиссёр' => 'kınorejısór','герцог' => 'gersog','траектория' => 'traektorıa','аялдама' => 'aıaldama','авиацияшы' => 'avıasıashy','қақшию' => 'qaqshıý','люк' => 'lúk','тилл' => 'tıl','агломерация' => 'aglomerasıa','оккупациялану' => 'okýpasıalaný','экспрессема' => 'ekspresema','көзбояушылық' => 'kózboıaýshylyq','тызғаяқ' => 'tyzǵaıaq','миясыз' => 'mıasyz','аутэкология' => 'aýtekologıa','коммунистік' => 'komýnıstik','демагог' => 'demagog','тарпию' => 'tarpıý','гастрономия' => 'gastronomıa','ұялау' => 'uıalaý','баяншы' => 'baıanshy','қияршөп' => 'qıarshóp','габбро-пегматит' => 'gabro-pegmatıt','эпитафия' => 'epıtafıa','марқаю' => 'marqaıý','пунктуациялық' => 'pýnktýasıalyq','валенттілік' => 'valenttilik','касса' => 'kasa','асимметрия' => 'asımetrıa','кают-компания' => 'kaıýt-kompanıa','сиялы' => 'sıaly','ванадий' => 'vanadı','морфография' => 'morfografıa','рия' => 'rıa','обсерваториялық' => 'observatorıalyq','эфтаназия' => 'eftanazıa','стилист' => 'stılıs','бас-аяғы' => 'bas-aıaǵy','аллашылдық' => 'allashyldyq','эндокринология' => 'endokrınologıa','гипертония' => 'gıpertonıa','траекториялы' => 'traektorıaly','шасси' => 'shası','парабеллум' => 'parabelým','тираннозавр' => 'tıranozavr','мұнай-химия' => 'munaı-hımıa','гравиметриялық' => 'gravımetrıalyq','конгломерация' => 'konglomerasıa','іннен-інге' => 'innen-inge','векторлық' => 'vektorlyq','қиялдану' => 'qıaldaný','гидрометрия' => 'gıdrometrıa','сықсию' => 'syqsıý','тысыраю' => 'tysyraıý','антикоррозиялық' => 'antıkorozıalyq','ауыртаяқ' => 'aýyrtaıaq','бояулы' => 'boıaýly','резервист' => 'rezervıs','перпендикулярлық' => 'perpendıkýlárlik','мыржию' => 'myrjıý','зияндас' => 'zıandas','лапарсия' => 'laparsıa','қояншеккі' => 'qoıanshekki','ирония' => 'ıronıa','гипюр' => 'gıpúr','хикаят' => 'hıkaıat','диалект' => 'dıalekt','идеограмма' => 'ıdeogram','шелтию' => 'sheltıý','жымию' => 'jymıý','пудинг' => 'pýdıń','әсіреинтернационалист' => 'ásireınternasıonalıs','орфография' => 'orfografıa','дефектолог' => 'defektolog','қауқию' => 'qaýqıý','саяқ' => 'saıaq','эллипстік' => 'elıpstik','сөмпию' => 'sómpıý','деривация' => 'derıvasıa','империялық' => 'ımperıalyq','ваниль' => 'vanıl','боулинг' => 'boýlıń','вагон' => 'vagon','жаннат' => 'jannat','академиялық' => 'akademıalyq','талпию' => 'talpıý','түю' => 'túıý','палеонтология' => 'paleontologıa','мифологиялық' => 'mıfologıalyq','пост' => 'post','тікию' => 'tikıý','аббаттық' => 'abattyq','калькуляциялау' => 'kálkýlásıalaý','аммонал' => 'amonal','алхимия' => 'alhımıa','бюрократияшылдық' => 'búrokratıashyldyq','атрибуция' => 'atrıbýsıa','теннисші' => 'tenısshi','аппликация' => 'aplıkasıa','травматологиялық' => 'travmatologıalyq','абсолюттік' => 'absolúttik','милиция' => 'mılısıa','қызылбояу' => 'qyzylboıaý','рентгенология' => 'rentgenologıa','қияс' => 'qıas','экстракция' => 'ekstraksıa','антономазия' => 'antonomazıa','сопаю' => 'sopaıý','гидрогеология' => 'gıdrogeologıa','электрхимия' => 'elektrhımıa','когниция' => 'kognısıa','авария' => 'avarıa','микробиологиялық' => 'mıkrobıologıalyq','аққоян' => 'aqqoıan','альманах' => 'álmanah','радиология' => 'radıologıa','петиция' => 'petısıa','лейшмания' => 'leıshmanıa','маркетинг' => 'marketıń','макропроцессор' => 'makroprosesor','киоск' => 'kıosk','бассүйектілер' => 'bassúıektiler','химиотерапия' => 'hımıoterapıa','библиография' => 'bıblıografıa','аутопсия' => 'aýtopsıa','феррография' => 'ferografıa','аялдай' => 'aıaldaı','экзарация' => 'ekzarasıa','аяншақтану' => 'aıanshaqtaný','репарация' => 'reparasıa','рапсодия' => 'rapsodıa','дарбию' => 'darbıý','структуралист' => 'strýktýralıs','ащысыну' => 'ashshysyný','филокартия' => 'fılokartıa','балшию' => 'balshıý','палеогеоморфология' => 'paleogeomorfologıa','яхт-клуб' => 'ıaht-klýb','миллимикрофон' => 'mıllımıkrofon','вегетериандық' => 'vegeterıandyq','феноменология' => 'fenomenologıa','кассирлік' => 'kasırlik','кассалық' => 'kasalyq','абстракт' => 'abstrakt','гегемония' => 'gegemonıa','вирусолог' => 'vırýsolog','шыбыртқыаяқты' => 'shybyrtqyaıaqty','координация' => 'koordınasıa','палеогеография' => 'paleogeografıa','аялдаушы' => 'aıaldaýshy','контаминация' => 'kontamınasıa','бүкірею' => 'búkireıý','келіссөз' => 'kelissóz','горилла' => 'gorıla','сияз' => 'sıaz','саяхатшы' => 'saıahatshy','аюбалдырған' => 'aıýbaldyrǵan','альбатрос' => 'álbatros','диффузия' => 'dıfýzıa','оппа' => 'oppa','олимпиялық' => 'olımpıalyq','құдию' => 'qudıý','бандероль' => 'banderól','большевизм' => 'bólshevızm','посткоммунистік' => 'postkomýnıstik','құссүзек' => 'qussúzek','гидрогеологиялық' => 'gıdrogeologıalyq','ұяңдық' => 'uıańdyq','жолдассыну' => 'joldassyný','тыртию' => 'tyrtıý','кумуляция' => 'kýmýlásıa','жассыну' => 'jassyný','варрант' => 'varant','коммуникациялық' => 'komýnıkasıalyq','тұяқсыз' => 'tuıaqsyz','аялдау' => 'aıaldaý','кульминация' => 'kúlmınasıa','кішірею' => 'kishireıý','бессайысшы' => 'bessaıysshy','металлургия' => 'metalýrgıa','жалтарыссыз' => 'jaltaryssyz','аяну' => 'aıaný','саясилану' => 'saıasılaný','хореография' => 'horeografıa','миниатюрашы' => 'mınıatúrashy','аянбай' => 'aıanbaı','комбинациялық' => 'kombınasıalyq','якут' => 'ıakýt','мұқиятсыздық' => 'muqıatsyzdyq','тіксию' => 'tiksıý','қалтарыссыз' => 'qaltaryssyz','ию' => 'ıý','аяқтасу' => 'aıaqtasý','магиялық' => 'magıalyq','перинатология' => 'perınatologıa','разрядшы' => 'razrádshi','ғақлия' => 'ǵaqlıa','дабыраю' => 'dabyraıý','хронография' => 'hronografıa','килокалория' => 'kılokalorıa','трансляция' => 'translásıa','аялдамадай' => 'aıaldamadaı','имидж' => 'ımıj','таяздық' => 'taıazdyq','монархиялық' => 'monarhıalyq','химия' => 'hımıa','аят' => 'aıat','тыңтұяқ' => 'tyńtuıaq','миллиграмдық' => 'mıllıgramdyq','сіргежияр' => 'sirgejıar','анестезиолог' => 'anestezıolog','мотивация' => 'motıvasıa','жариялану' => 'jarıalaný','спиннинг' => 'spınıń','мияулату' => 'mıaýlatý','ноян' => 'noıan','осциллография' => 'osılografıa','мобилизациялау' => 'mobılızasıalaý','ащы-тәтті' => 'ashshy-tátti','ваттық' => 'vattyq','велокросс' => 'velokros','таяқтау' => 'taıaqtaý','коэффициент' => 'koefısıent','дивизиялық' => 'dıvızıalyq','тұяқтас' => 'tuıaqtas','кесе-аяқ' => 'kese-aıaq','туннель' => 'týnel','аяң-жортақ' => 'aıań-jortaq','мұңаю' => 'muńaıý','қақыраю' => 'qaqyraıý','қоңылтаяқ' => 'qońyltaıaq','геоморфологиялық' => 'geomorfologıalyq','қаупию' => 'qaýpıý','жаядай' => 'jaıadaı','бойдақ-саяқ' => 'boıdaq-saıaq','фитоценология' => 'fıtosenologıa','деформациялану' => 'deformasıalaný','хромолитография' => 'hromolıtografıa','холл' => 'hol','үлессіз' => 'úlessiz','теллур' => 'telýr','қоянаяқ' => 'qoıanaıaq','мықию' => 'myqıý','галактоземия' => 'galaktozemıa','крест' => 'kres','шайқассыз' => 'shaıqassyz','микрометрия' => 'mıkrometrıa','макроассемблер' => 'makroasembler','роялист' => 'roıalıs','мюзик-холл' => 'múzık-hol','алюминотермия' => 'alúmınotermıa','гносеологиялық' => 'gnoseologıalyq','аллигатор' => 'alıgator','терминология' => 'termınologıa','олигархия' => 'olıgarhıa','дециграмм' => 'desıgram','токсикология' => 'toksıkologıa','минералогия' => 'mıneralogıa','веб-құрамдас' => 'veb-quramdas','мобилизациялану' => 'mobılızasıalaný','қаяу-қайғы' => 'qaıaý-qaıǵy','масаю' => 'masaıý','аллергия' => 'alergıa','қиялес' => 'qıales','гравюралау' => 'gravúralaý','капелла' => 'kapela','эвапотранспирация' => 'evapotranspırasıa','миография' => 'mıografıa','геоморфология' => 'geomorfologıa','қоян-қолтық' => 'qoıan-qoltyq','бояушылық' => 'boıaýshylyq','клиринг' => 'klırıń','салбыраю' => 'salbyraıý','классикалық' => 'klasıkalyq','диалог' => 'dıalog','миопатия' => 'mıopatıa','аттестат' => 'atestat','морфолог' => 'morfolog','киноматография' => 'kınomatografıa','биогеологиялық' => 'bıogeologıalyq','мияттай' => 'mıattaı','тұяқты' => 'tuıaqty','биопсия' => 'bıopsıa','физиологиялық' => 'fızıologıalyq','қатыссыз' => 'qatyssyz','баббит' => 'babıt','бояусыз' => 'boıaýsyz','вирус' => 'vırýs','аяқдоп' => 'aıaqdop','фенокопия' => 'fenokopıa','астрохимия' => 'astrohımıa','шалқаяқтау' => 'shalqaıaqtaý','омонимия' => 'omonımıa','парфюмерия' => 'parfúmerıa','микрохимия' => 'mıkrohımıa','вермикулит' => 'vermıkýlıt','океанография' => 'okeanografıa','қоғамдық-саяси' => 'qoǵamdyq-saıası','тұщылану' => 'tushshylaný','велоспорт' => 'velosport','графология' => 'grafologıa','қаяу' => 'qaıaý','бемоль' => 'bemól','ақыраю' => 'aqyraıý','конъюгация' => 'konúgasıa','тоятсыз' => 'toıatsyz','джерси' => 'jersı','гамма-сәуле' => 'gamma-sáýle','агробиолог' => 'agrobıolog','кіжірею' => 'kijireıý','эпистолярлық' => 'epıstolárlyq','қаярсу' => 'qaıarsý','тонналау' => 'tonnalaý','қоян' => 'qoıan','кассир' => 'kasır','гонококк' => 'gonokok','биогеография' => 'bıogeografıa','бадыраю' => 'badyraıý','амбулаториялық' => 'ambýlatorıalyq','цитолог' => 'sıtolog','вакуумдау' => 'vakýmdaý','вуда' => 'výda','дискриминация' => 'dıskrımınasıa','қаджари' => 'qadjarı','конверсиялық' => 'konversıalyq','авиатрасса' => 'áýejol','астрономия' => 'astronomıa','қоянтобық' => 'qoıantobyq','мәссаған' => 'mássaǵan','дорбию' => 'dorbıý','саяттату' => 'saıattatý','ведомость' => 'vedimis','антимонополия' => 'antımonopolıa','аускультациялық' => 'aýskúltasıalyq','целлюлоза' => 'selúloza','тиянақ' => 'tıanaq','деформациялық' => 'deformasıalyq','вокал' => 'vokal','сықию' => 'syqıý','мұсабба' => 'musabba','валюта' => 'valúta','пресс' => 'pres','геохронологиялық' => 'geohronologıalyq','желқұяң' => 'jelquıań','тұқым-тұқиян' => 'tuqym-tuqıan','дедукциялы' => 'dedýksıaly','аллювий' => 'alúvi','бюрократия' => 'búrokratıa','бұлтию' => 'bultıý','академия' => 'akademıa','литология' => 'lıtologıa','футурист' => 'fýtýrıs','аяншақтау' => 'aıanshaqtaý','рентгенологиялық' => 'rentgenologıalyq','хедж' => 'hej','бірпартиялық' => 'birpartıalyq','экспрессионизм' => 'ekspresıonızm','фотолитография' => 'fotolıtografıa','училище' => 'ýchılıshe','биязылау' => 'bıazylaý','аллергиялық' => 'alergıalyq','дедукциялық' => 'dedýksıalyq','тызғаяқтату' => 'tyzǵaıaqtatý','жүкаяқ' => 'júkaıaq','аялдауыш' => 'aıaldaýysh','басмия' => 'basmıa','пайда-зиян' => 'paıda-zıan','құрылымдық-формациялық' => 'qurylymdyq-formasıalyq','қапия' => 'qapıa','қытайпияз' => 'qytaıpıaz','ют' => 'ıýt','оюластыру' => 'oıýlastyrý','аксиология' => 'aksıologıa','авторитарлық-бюрократиялық' => 'avtorıtarlyq-búrokratıalyq','вируленттілік' => 'vırýlenttilik','электронография' => 'elektronografıa','гидрогеолог' => 'gıdrogeolog','баяғы' => 'baıaǵy','кілбию' => 'kilbıý','саяттау' => 'saıattaý','фенология' => 'fenologıa','муссон' => 'mýson','тапыраю' => 'tapyraıý','кейкию' => 'keıkıý','оқшию' => 'oqshıý','неомифологиялық' => 'neomıfologıalyq','нитрификация' => 'nıtrıfıkasıa','құмқияқ' => 'qumqıaq','төтеннен' => 'tótennen','ұяңдату' => 'uıańdatý','кекшию' => 'kekshıý','инкассация' => 'ınkasasıa','парфюмерлік' => 'parfúmerlik','аннотация' => 'anotasıa','байланыссыздық' => 'baılanyssyzdyq','батарея' => 'batareıa','артель' => 'artel','апофония' => 'apofonıa','ватт-секунд' => 'vatt-sekýnd','жалаңаяқтық' => 'jalańaıaqtyq','партиялық' => 'partıalyq','дефектология' => 'defektologıa','әкімият' => 'ákimıat','соян' => 'soıan','пропорциялық' => 'proporsıalyq','амузия' => 'amýzıa','тетрология' => 'tetrologıa','арамсояу' => 'aramsoıaý','қиял-ой' => 'qıal-oı','индукциялау' => 'ındýksıalaý','аял' => 'aıal','ранг' => 'rang','зиянсыздандыру' => 'zıansyzdandyrý','қосаяқ' => 'qosaıaq','қиянкестік' => 'qıankestik','үю' => 'úıý','тонна-километр' => 'tonna-kılometr','модулятор' => 'modýlátor','иллюминатор' => 'ılúmınator','бас-аяқсыз' => 'bas-aıaqsyz','франчайзинг' => 'franchaızıń','қиямпұрыс' => 'qıampurys','анизотропия' => 'anızotropıa','әсіреаянпаздық' => 'ásireaıanpazdyq','сегізаяқ' => 'segizaıaq','геотехнологиялық' => 'geotehnologıalyq','қиялшыл' => 'qıalshyl','инкубация' => 'ınkýbasıa','аюжүн' => 'aıýjún','макромаркетинг' => 'makromarketıń','бояушөп' => 'boıaýshóp','фиксинг' => 'fıksıń','фортиссимо' => 'fortısımo','тотияйындау' => 'totıaıyndaý','тию' => 'tıý','дзюдошы' => 'dzúdoshy','аяң-жортаң' => 'aıań-jortań','тасқаяқшы' => 'tasqaıaqshy','эллипсті' => 'elıpsti','қоқию' => 'qoqıý','фразеология' => 'frazeologıa','сияқтандыру' => 'sıaqtandyrý','аппендикс' => 'apendıks','оюшы' => 'oıýshy','тырбию' => 'tyrbıý','жалқаяқ' => 'jalqaıaq','орфограмма' => 'orfogram','профессорлық' => 'profesorlyq','миссионерлік' => 'mısıonerlik','фотография' => 'fotografıa','даяр' => 'daıar','алааяқтық' => 'alaaıaqtyq','эвакуациялану' => 'evakýasıalaný','ингаляциялау' => 'ıngalásıalaý','эксплозиялық' => 'eksplozıalyq','баллистика' => 'balıstıka','тылтию' => 'tyltıý','лякросс' => 'lákros','әсіресаясаттану' => 'ásiresaıasattaný','ащылану' => 'ashshylaný','шаянтектестер' => 'shaıantektester','радиотрансляция' => 'radıotranslásıa','аккумуляторлы' => 'akýmýlátorly','әуекасса' => 'áýekasa','гидрогеохимиялық' => 'gıdrogeohımıalyq','нейрохирургиялық' => 'neırohırýrgıalyq','кею' => 'keıý','монополияландыру' => 'monopolıalandyrý','электркардиограмма' => 'elektrkardıogram','невролог' => 'nevrolog','географиялық' => 'geografıalyq','оккупация' => 'okýpasıa','дилемма' => 'dılem','фтизиатрия' => 'ftızıatrıa','металл' => 'metal','аннуитеттік' => 'anýıtettik','тератология' => 'teratologıa','экструзия' => 'ekstrýzıa','вице-канцлер' => 'vıse-kansler','қазұялы' => 'qazuıaly','морфонология' => 'morfonologıa','ядрошықты' => 'ıadroshyqty','эпитаксия' => 'epıtaksıa','тұщылық' => 'tushshylyq','цитологиялық' => 'sıtologıalyq','хеджер' => 'hejer','сақтиян' => 'saqtıan','фаталист' => 'fatalıs','ақтұяқ' => 'aqtuıaq','тұщы' => 'tushshy','социалист' => 'sosıalıs','тыюлы' => 'tyıýly','субъективист' => 'sýbektıvıs','реквизициялау' => 'rekvızısıalaý','глюкоза' => 'glúkoza','тап-таяу' => 'tap-taıaý','флювиогляциалдық' => 'flúvıoglásıaldyq','мнемограмма' => 'mnemogram','лексика-грамматикалық' => 'leksıka-gramatıkalyq','полярлану' => 'polárlaný','алхимиялық' => 'alhımıalyq','эгопсихология' => 'egopsıhologıa','реквизиция' => 'rekvızısıa','үнжария' => 'únjarıa','мүдделілік' => 'múddelilik','адмиралиссимус' => 'admıralısımýs','урология' => 'ýrologıa','милленаристік' => 'mılenarıstik','коммуна' => 'komýna','реминисценция' => 'remınısensıa','менингококк' => 'menıngokok','амортизация' => 'amortızasıa','қиялдау' => 'qıaldaý','таяқтастам' => 'taıaqtastam','бактерия' => 'bakterıa','күрбию' => 'kúrbıý','гистологиялық' => 'gıstologıalyq','солист' => 'solıs','адаптация' => 'adaptasıa','эволюция' => 'evolúsıa','аттестаттау' => 'atestattaý','пассив' => 'pasıv','жая' => 'jaıa','трагедиялық' => 'tragedıalyq','аяқ-қолы' => 'aıaq-qoly','тарақия' => 'taraqıa','дәлию' => 'dálıý','калькулятор' => 'kálkýlátor','интервенциялық' => 'ıntervensıalyq','палладий' => 'paladı','қоқыраю' => 'qoqyraıý','көнтию' => 'kóntıý','қияқөлең' => 'qıaqóleń','естияр' => 'estıar','талтию' => 'taltıý','қисса' => 'qıssa','типологиялық' => 'tıpologıalyq','антимонополиялық' => 'antımonopolıalyq','граммема' => 'gramem','оккупант' => 'okýpant','альтерация' => 'álterasıa','топонимия' => 'toponımıa','тып-тиянақты' => 'typ-tıanaqty','кавалерист' => 'kavalerıs','пункт' => 'pýnkt','таяқша' => 'taıaqsha','ипподром' => 'ıpodrom','айтыссыз' => 'aıtyssyz','разрядтау' => 'razrádteý','аяқбас' => 'aıaqbas','қия-таулы' => 'qıa-taýly','тосыннан' => 'tosynnan','аускультация' => 'aýskúltasıa','ықтиятты' => 'yqtıatty','ғылыми-теориялық' => 'ǵylymı-teorıalyq','вахтёр' => 'vahtór','линогравюра' => 'lınogravúra','тақиятеппек' => 'taqıateppek','қутұяқ' => 'qýtuıaq','фототопография' => 'fototopografıa','қияқшы' => 'qıaqshy','жезаяқ' => 'jezaıaq','армия' => 'armıa','агроэкологиялық' => 'agroekologıalyq','саяттану' => 'saıattaný','биотехниялық' => 'bıotehnıalyq','тұштию' => 'tushtıý','фотохимия' => 'fotohımıa','мүдде' => 'múdde','вади' => 'vadı','маятник' => 'maıatnık','микрофотография' => 'mıkrofotografıa','күжірею' => 'kújireıý','экотоксикология' => 'ekotoksıkologıa','миссионер' => 'mısıoner','минералог' => 'mıneralog','қосаяқша' => 'qosaıaqsha','кальмар' => 'kálmar','монополиялау' => 'monopolıalaý','гамбузия' => 'gambýzıa','дағдарыссыз' => 'daǵdaryssyz','модификация' => 'modıfıkasıa','вольт-ампер' => 'vólt-amper','ұяңдану' => 'uıańdaný','вариолдар' => 'varıoldar','саялату' => 'saıalatý','дозиметрия' => 'dozımetrıa','конгрессмен' => 'kongresmen','виолончель' => 'vıolonchel','автономиялық' => 'avtonomıalyq','статист' => 'statıs','пунктуация' => 'pýnktýasıa','аллеялы' => 'aleıaly','қоянша' => 'qoıansha','даярлау' => 'daıarlaý','чекист' => 'chekıs','калька' => 'kálka','галерея' => 'galereıa','гиподинамия' => 'gıpodınamıa','валиум' => 'valıým','өріссіз' => 'órissiz','биязылық' => 'bıazylyq','аккредитивтік' => 'akredıtıvtik','тояттату' => 'toıattatý','фортепьяно' => 'fortepáno','тыжыраю' => 'tyjyraıý','баяндату' => 'baıandatý','фисгармония' => 'fısgarmonıa','хирургиялық' => 'hırýrgıalyq','юглон' => 'ıýglon','оюласу' => 'oıýlasý','гомеотерапия' => 'gomeoterapıa','веб-сайт' => 'veb-saıt','сиябүріккіш' => 'sıabúrikkish','мұздаяқ' => 'muzdaıaq','қисая-қисая' => 'qısaıa-qısaıa','коньки' => 'kónkı','шовинист' => 'shovınıs','кикбоксинг' => 'kıkboksıń','волютин' => 'volútın','құю' => 'quıý','репродукциялық' => 'reprodýksıalyq','ояз' => 'oıaz','аяластыру' => 'aıalastyrý','кульминациялық' => 'kúlmınasıalyq','нейрофизиология' => 'neırofızıologıa','голландиялық' => 'golandıalyq','япыр-ай' => 'ıapyr-aı','объектив' => 'obektıv','операция' => 'operasıa','геодезиялық' => 'geodezıalyq','сықаяқ' => 'syqaıaq','сымпию' => 'sympıý','орфоэпия' => 'orfoepıa','ассимиляциялану' => 'asımılásıalaný','абсолют' => 'absolút','гематолог' => 'gematolog','баллада' => 'ballada','диссертациялық' => 'dısertasıalyq','анимация' => 'anımasıa','хореографиялық' => 'horeografıalyq','ярд' => 'ıard','демобилизациялану' => 'demobılızasıalaný','бессайыс' => 'bessaıys','бейсаясатшылдық' => 'beısaıasatshyldyq','окулист' => 'okýlıs','бассүйексіздер' => 'bassúıeksizder','тақиятастамақ' => 'taqıatastamaq','иерархия' => 'ıerarhıa','көбею' => 'kóbeıý','бұрылыссыз' => 'burylyssyz','пресс-бюро' => 'pres-búro','объективтілік' => 'obektıvtilik','зоолог' => 'zoolog','журналист' => 'jýrnalıs','шоңқаю' => 'shońqaıý','биязылану' => 'bıazylaný','махаббат' => 'mahabbat','макросемья' => 'makrosemıa','аярлық' => 'aıarlyq','терраса' => 'terasa','хлорофилл' => 'hlorofıl','монокулярлық' => 'monokýlárlik','гемералопия' => 'gemeralopıa','шадыраю' => 'shadyraıý','даярлату' => 'daıarlatý','ықтиярсыздық' => 'yqtıarsyzdyq','далдию' => 'daldıý','шілия' => 'shilıa','бацилла' => 'basıla','өсек-аяң' => 'ósek-aıań','аяқсыту' => 'aıaqsytý','сапиян' => 'sapıan','инженер-технолог' => 'ınjener-tehnolog','плеврококк' => 'plevrokok','сарғаю' => 'sarǵaıý','юзер' => 'ıýzer','остеология' => 'osteologıa','құшып-сүю' => 'qushyp-súıý','эмоциялы' => 'emosıaly','шуаяқ' => 'shýaıaq','желмаяша' => 'jelmaıasha','вазелин' => 'vazelın','аяқсыз' => 'aıaqsyz','операциялық' => 'operasıalyq','эмпирия' => 'empırıa','дзюдо' => 'dzúdo','аяқсу' => 'aıaqsý','тоятшыл' => 'toıatshyl','бәдия' => 'bádıa','репродукция' => 'reprodýksıa','алатұяқ' => 'alatuıaq','коньяк' => 'konák','қиян' => 'qıan','шыбыртқыаяқтылар' => 'shybyrtqyaıaqtylar','профессор' => 'profesor','ринг' => 'rıng','минераграфия' => 'mıneragrafıa','шлюз' => 'shlúz','коллоид' => 'koloıd','аномалия' => 'anomalıa','аккомодаттану' => 'akomodattaný','компакт-диск' => 'kompakt-dısk','доптаяқ' => 'doptaıaq','аккомпаниатор' => 'akompanıator','құпияландыру' => 'qupıalandyrý','арбию' => 'arbıý','дүрия' => 'dúrıa','петрографиялық' => 'petrografıalyq','қаяз' => 'qaıaz','физиотерапия' => 'fızıoterapıa','синдикалист' => 'sındıkalıs');

    public static function Cyrl2Latyn($cyrlText)
    {
        $cyrlText = self::CopycatCyrlToOriginalCyrl($cyrlText);
        $cyrlText.='.';
        $chars = preg_split('/(?<!^)(?!$)/u', $cyrlText );
        $length = count($chars);
        $latynStrs = array();
        $firstCharIsUpper = false;
        $prevSound = Sound::Unknown;
        $cyrlWord = '';
        for ($i = 0; $i < $length; $i++) {
            if (!in_array(mb_strtoupper($chars[$i]), self::$cyrlChars))
            {
                if(mb_strlen($cyrlWord, 'UTF-8') != 0)
                {
                    $wordLength = mb_strlen($cyrlWord, 'utf-8');
                    $k = $wordLength;
                    $j = ($i - $wordLength);

                    for (; $k > 3 || ($wordLength == 3 && $k >= 3) || ($wordLength == 2 && $k >= 2); $k--)
                    {
                        $wpKey = mb_strtolower(mb_substr($cyrlWord, 0, $k, 'utf-8'));
                        if (array_key_exists($wpKey, self::$wordsPackDic)) {
                            $latynStrs[$j] = self::ConvertWord(mb_substr($cyrlWord, 0, $k, 'utf-8'), self::$wordsPackDic[$wpKey]);
                            $j += $k;
                            break;
                        }

                    }
                    $cyrlWord = mb_strtolower( $cyrlWord);//.ToLower();
                    $lastIsUpper = false;
                    $prevIsC = false;
                    $firstCharIsUpper = mb_strtoupper($chars[$j])===($chars[$j]);
                    $lastStartIndex = $j;
                    for (; $j < $i; $j++)
                    {
                        if ($j > $lastStartIndex)
                        {
                            $prevSound = in_array(mb_strtoupper($chars[$j - 1]),self::$vowelChars) ? Sound::Vowel : Sound::Consonant;
                            $prevIsC = mb_strtolower($chars[$j - 1]) === 'с';
                        }
                        if ($j != $length - 1 && in_array(mb_strtoupper($chars[$j + 1]),self::$cyrlChars) && $chars[$j + 1] == mb_strtoupper($chars[$j + 1]))
                        {

                            $lastIsUpper = true;
                        }
                        if ($wordLength > 3)  //Word end 3 char
                        {
                            $key = $chars[$i - 3].$chars[$i - 2].$chars[$i - 1];
                            switch (mb_strtolower($key))
                            {
                                case 'сть': { $chars[$i] = ''; $chars[$i - 1] = ''; } break;
                            }
                        }
                        if ($j + 1 < $length)
                        {
                            $key = $chars[$j] . $chars[$j + 1];
                            switch (mb_strtolower($key))
                            {
                                case 'ия':
                                    { $latynStrs[$j] = self::ConvertWord($key, 'ıa'); $j += 1; continue; }
                                case 'йя':
                                    { $latynStrs[$j] = self::ConvertWord($key, 'ııa'); $j += 1; continue; }
                                case 'ию':
                                    { $latynStrs[$j] = self::ConvertWord($key, 'ıý'); $j += 1; continue; }
                                case 'йю':
                                    { $latynStrs[$j] = self::ConvertWord($key, 'ıý'); $j += 1; continue; }
                                case 'сц':
                                    { $latynStrs[$j] = self::ConvertWord($key, 's'); $j += 1; continue; }
                                case 'тч':
                                    { $latynStrs[$j] = self::ConvertWord($key, 'ch'); $j += 1; continue; }
                                case 'ий':
                                    { $latynStrs[$j] = self::ConvertWord($key, 'ı'); $j += 1; continue; }
                                case 'ХХ': { $latynStrs[$j] = 'ХХ'; $j += 1; continue; }
                            }
                        }
                        switch ($chars[$j])
                        {
                            case 'Я': { $latynStrs[$j] = $prevSound == Sound::Consonant ? 'Á' : 'Ia'; } break;
                            case 'я': { $latynStrs[$j] = $prevSound == Sound::Consonant ? 'á' : 'ıa'; } break;
                            case 'Ю': { $latynStrs[$j] = $prevSound == Sound::Consonant ? 'Ú' : 'Iý'; } break;
                            case 'ю': { $latynStrs[$j] = $prevSound == Sound::Consonant ? 'ú' : 'ıý'; } break;
                            case 'Щ': { $latynStrs[$j] = $lastIsUpper ? 'SH' : 'Sh'; } break;
                            case 'щ': { $latynStrs[$j] = 'sh'; } break;
                            case 'Э': { $latynStrs[$j] = 'E'; } break;
                            case 'э': { $latynStrs[$j] = 'e'; } break;
                            case 'А': { $latynStrs[$j] = 'A'; } break;
                            case 'а': { $latynStrs[$j] = 'a'; } break;
                            case 'Б': { $latynStrs[$j] = 'B'; } break;
                            case 'б': { $latynStrs[$j] = 'b'; } break;
                            case 'Ц': { $latynStrs[$j] = 'S'; } break;
                            case 'ц': { $latynStrs[$j] = 's'; } break;
                            case 'Д': { $latynStrs[$j] = 'D'; } break;
                            case 'д': { $latynStrs[$j] = 'd'; } break;
                            case 'Е': { $latynStrs[$j] = 'E'; } break;
                            case 'е': { $latynStrs[$j] = 'e'; } break;
                            case 'Ф': { $latynStrs[$j] = 'F'; } break;
                            case 'ф': { $latynStrs[$j] = 'f'; } break;
                            case 'Г': { $latynStrs[$j] = 'G'; } break;
                            case 'г': { $latynStrs[$j] = 'g'; } break;
                            case 'Х': { $latynStrs[$j] = $prevIsC ? 'Q' : 'H'; } break;
                            case 'х': { $latynStrs[$j] = $prevIsC ? 'q' : 'h'; } break;
                            case 'Һ': { $latynStrs[$j] = 'H'; } break;
                            case 'һ': { $latynStrs[$j] = 'h'; } break;
                            case 'І': { $latynStrs[$j] = 'İ'; } break;
                            case 'і': { $latynStrs[$j] = 'i'; } break;
                            case 'И': { $latynStrs[$j] = 'I'; } break;
                            case 'и': { $latynStrs[$j] = 'ı'; } break;
                            case 'Й': { $latynStrs[$j] = 'I'; } break;
                            case 'й': { $latynStrs[$j] = 'ı'; } break;
                            case 'К': { $latynStrs[$j] = 'K'; } break;
                            case 'к': { $latynStrs[$j] = 'k'; } break;
                            case 'Л': { $latynStrs[$j] = 'L'; } break;
                            case 'л': { $latynStrs[$j] = 'l'; } break;
                            case 'М': { $latynStrs[$j] = 'M'; } break;
                            case 'м': { $latynStrs[$j] = 'm'; } break;
                            case 'Н': { $latynStrs[$j] = 'N'; } break;
                            case 'н': { $latynStrs[$j] = 'n'; } break;
                            case 'О': { $latynStrs[$j] = 'O'; } break;
                            case 'о': { $latynStrs[$j] = 'o'; } break;
                            case 'П': { $latynStrs[$j] = 'P'; } break;
                            case 'п': { $latynStrs[$j] = 'p'; } break;
                            case 'Қ': { $latynStrs[$j] = 'Q'; } break;
                            case 'қ': { $latynStrs[$j] = 'q'; } break;
                            case 'Р': { $latynStrs[$j] = 'R'; } break;
                            case 'р': { $latynStrs[$j] = 'r'; } break;
                            case 'С': { $latynStrs[$j] = 'S'; } break;
                            case 'с': { $latynStrs[$j] = 's'; } break;
                            case 'Т': { $latynStrs[$j] = 'T'; } break;
                            case 'т': { $latynStrs[$j] = 't'; } break;
                            case 'Ұ': { $latynStrs[$j] = 'U'; } break;
                            case 'ұ': { $latynStrs[$j] = 'u'; } break;
                            case 'В': { $latynStrs[$j] = 'V'; } break;
                            case 'в': { $latynStrs[$j] = 'v'; } break;
                            case 'У': { $latynStrs[$j] = 'Ý'; } break;
                            case 'у': { $latynStrs[$j] = 'ý'; } break;
                            case 'Ы': { $latynStrs[$j] = 'Y'; } break;
                            case 'ы': { $latynStrs[$j] = 'y'; } break;
                            case 'З': { $latynStrs[$j] = 'Z'; } break;
                            case 'з': { $latynStrs[$j] = 'z'; } break;
                            case 'Ә': { $latynStrs[$j] = 'Á'; } break;
                            case 'ә': { $latynStrs[$j] = 'á'; } break;
                            case 'Ё':
                            case 'Ө': { $latynStrs[$j] = 'Ó'; } break;
                            case 'ё':
                            case 'ө': { $latynStrs[$j] = 'ó'; } break;
                            case 'Ү': { $latynStrs[$j] = 'Ú'; } break;
                            case 'ү': { $latynStrs[$j] = 'ú'; } break;
                            case 'Ч': { $latynStrs[$j] = $lastIsUpper ? 'CH' : 'Ch'; } break;
                            case 'ч': { $latynStrs[$j] = 'ch'; } break;
                            case 'Ғ': { $latynStrs[$j] = 'Ǵ'; } break;
                            case 'ғ': { $latynStrs[$j] = 'ǵ'; } break;
                            case 'Ш': { $latynStrs[$j] = $lastIsUpper ? 'SH' : 'Sh'; } break;
                            case 'ш': { $latynStrs[$j] = 'sh'; } break;
                            case 'Ж': { $latynStrs[$j] = 'J'; } break;
                            case 'ж': { $latynStrs[$j] = 'j'; } break;
                            case 'Ң': { $latynStrs[$j] = 'Ń'; } break;
                            case 'ң': { $latynStrs[$j] = 'ń'; } break;
                            case 'ь': { $latynStrs[$j] = ''; } break;
                            case 'Ь': { $latynStrs[$j] = ''; } break;
                            case 'ъ': { $latynStrs[$j] = ''; } break;
                            case 'Ъ': { $latynStrs[$j] = ''; } break;
                            case '¬': { $latynStrs[$j] = ''; } break;
                            default: { $latynStrs[$j] = $chars[$j] != '' ? $chars[$j] : ''; } break;
                        }
                    }
                    $cyrlWord = '';
                }
                $latynStrs[$i] = $chars[$i];
                $prevSound = Sound::Unknown;
                continue;
            }
            $cyrlWord .= $chars[$i];
            $prevSound = Sound::Unknown;
        }

        $latynStrs[$length - 1] = '';
        return join('', $latynStrs);

    }

    private static function CopycatCyrlToOriginalCyrl($cyrlText)
    {
        $cyrlText = str_replace('Ə', 'Ә', $cyrlText);
        $cyrlText = str_replace('ə', 'ә', $cyrlText);
        $cyrlText = str_replace('Ɵ', 'Ө', $cyrlText);
        $cyrlText = str_replace('ɵ', 'ө', $cyrlText);
        return $cyrlText;
    }

    private static function QazLatynToLower($latynText)
    {
        $latynText = str_replace('I', 'ı',$latynText);
        $latynText = str_replace('İ', 'i',$latynText);
        return  mb_strtolower($latynText);
    }

    private static function  QazLatynToUpper($latynText)
    {
        $latynText = str_replace('ı', 'I',$latynText);
        $latynText = str_replace('i', 'İ',$latynText);
        return mb_strtoupper($latynText);
    }

    private static function FirstCharToUpper($input)
    {
        if (mb_strlen($input, 'UTF-8') == 0)
            return $input;
        $encoding='utf-8';
        return self::QazLatynToUpper(mb_substr($input, 0, 1, $encoding)).mb_substr($input, 1, mb_strlen($input, $encoding) - 1, $encoding);
    }

    private static function ConvertWord($oldValue, $newValue)
    {
        if (strlen($oldValue)==0) return '';


        return $oldValue===(self::QazLatynToUpper($oldValue)) ? self::QazLatynToUpper($newValue) :
            $oldValue===(self::FirstCharToUpper($oldValue)) ? self::FirstCharToUpper($newValue) : self::QazLatynToLower($newValue);
    }

}
